/*
 * @author Walther Neuper, member of the ISAC-team, 
 * Copyright (c) 2004 by Walther Neuper 
 * created Sep 7, 2004, 2:39:29 PM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to license terms.
 */
package isac;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

/**
 * Collect the testcases and testsuites of isac-java.
 * 
 * ###########################################################################
 * ATTENTION: running the tests requires BridgeMain, KEStore and ObjectManager
 * to be launched before !!!
 * ###########################################################################
 * 
 * Note for test developers: make tests dependent only from setup
 * on individual workstation (NO remote processes) by
 * (a) fetch paths for tests from respective *.property OR
 * (b) stay with paths within the local directory
 * 
 * Note on accidental dependencies:
 * WN170215: @see isac.users.TestUserManager destroys subsequent tests, see comment there.
 *
 * @author Walther Neuper Oct 1, 2004, 3:44:31 PM
 */
public class Testall extends TestCase {

    public static Test suite() {
        System.out.println("/--BEGIN isac.Testall");
        TestSuite suite = new TestSuite("isac.Testall");

        //module-tests from subdirectories
        suite.addTest(isac.bridge.Testall.suite());//requires BridgeMain to run
        suite.addTest(isac.browserdialog.Testall.suite());
        suite.addTest(isac.functest.Testall.suite());
        suite.addTest(isac.gui.Testall.suite());//jfcunit outcommented
        suite.addTest(isac.kestore.Testall.suite());
        suite.addTest(isac.session.Testall.suite());
        //                 TESTUTIL ...no JUnit TestCase
        suite.addTest(isac.users.Testall.suite());
        suite.addTest(isac.util.Testall.suite());
        suite.addTest(isac.wsdialog.Testall.suite());

        //tests from this directory
        //TestConstants   ...no JUnit TestCase
        //TestException   ...no JUnit TestCase
        

        System.out.println("\\--END   isac.Testall");
        return suite;
    }

}