/*
 * #############################################################################
 * ATTENTION: BridgeMain must be started because of BridgeRMI (design fault) !?!
 * #############################################################################
 * 
 * @author Walther Neuper, member of the ISAC-team, Copyright (c) 2004 by
 * Walther Neuper created Aug 30, 2004, 11:58:35 AM Institute for
 * Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to license terms.
 */
package isac.bridge;

import isac.TestConstants;

import java.util.Vector;

import org.apache.log4j.Logger;

//import isac.interfaces.ICalcElement;
import isac.interfaces.ICalcIterator;
import isac.interfaces.IToCalc;
import isac.interfaces.IToUser;
import isac.kestore.KEStoreServices;
import isac.util.CalcChanged;
import isac.util.Formalization;
//import isac.util.formulae.Assumptions;
//import isac.util.formulae.CalcFormula;
//import isac.util.formulae.CalcHead;
//import isac.util.formulae.Formula;
import isac.util.formulae.Position;
import isac.util.parser.FormalizationDigest;
import isac.util.tactics.Tactic;
import junit.framework.TestCase;

/**
 * @author Walther Neuper Aug 30, 2004, 11:58:35 AM
 * 
 * ATTENTION: if these tests fail,
 * @see {isac.util.parser.TestFormalizationDigest.java} if formalization has
 *      changed, i.e. if there is an error to be handled first:
 * 
 * the file 'step_a.fmz' is _VERY_ sensible against changes in Formalization, it
 * is copied from isac/util/parser/data/exp_IsacCore_Tests_1b.fmz
 */
public class TestBridge extends TestCase {

    static Logger logger_ = Logger.getLogger(MathEngine.class.getName());

//    /**
//     * tests the example 'IsacCore/Tests/minipbl_with_mini-subpbl' comprising UC
//     * 'start auto calculation' \label{SPECIFY:START:auto}
//     *
//     * @see TestSolve#testAutoButton
//     */
//    public void testMinisubpblAutoCalc() throws Exception {
//        System.out.println("---BEGIN isac.bridge.TestBridge#testMinisubpblAutoCalc");
//
//        //load the file of the example,
//        //see TestKEStoreServices#testLoadContentMinisubpbl
//        KEStoreServices ks = new KEStoreServices(TestConstants.KESTORE.XMLDATA_PATH);
//        Vector<String> vec = ks.loadContent("exp", TestConstants.KESTORE.TEST_DATA.EXP_TESTS_1B);
//        //parse out the Formalization
//        //see TestFormalizationDigest#testParseExplMini
//        String xmlstr = (String) vec.firstElement();
//        FormalizationDigest fd = new FormalizationDigest();
//        Formalization fmz = fd.parseFormalization((String) xmlstr);
//        System.out.println(".end step_a-----");
//
//        //start the calculation
//        MathEngine.init("localhost");
//        MathEngine me = MathEngine.getMathEngine();
//
//        IToCalc ct = me.getCalcTree(fmz);
//        IToUser user = new MockIToDialog();
//        ct.addDataChangeListener(user);
//        CalcChanged cce = null;
//        System.out.println(".end step_a-----");
//        //end step_a
//        // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//
//        // this step is dropped in test-isac-java--isac-kernel.txt for PIDE-interface
//        // ct.completeCalcHead();
//        // sent to bridge: autoCalculate 1 CompleteCalcHead;
//        ICalcIterator ci = ct.getActiveFormula();
//        //######^ drop: push addDataChangeListener towards/into
//        //######^ startCalculation and fetch ci from CalcChanged:
//        //ci = (ICalcIterator) cce.getLastGeneratedFormula().clone();
//        CalcHead ch = (CalcHead) ci.getFormula();
//        System.out.println(".end step_b-----");
//        //end step_b
//        // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//
//        //autoCalculate
//        System.out.println(".autoCalculate");
//        ct.autoCalculate(IToCalc.SCOPE_CALCULATION, 0);
//
//        cce = ((MockIToDialog) user).getCalcChangedEvent();
//        // change due to above step dropped in test-isac-java--isac-kernel.txt for PIDE-interface
//        //assertEquals("unchanged", cce.getLastUnchangedFormula().toSMLString(),
//        //        "([],Met)");
//        //assertEquals("deleted", cce.getLastDeletedFormula().toSMLString(),
//        //        "([],Met)");
//        assertEquals("unchanged", cce.getLastUnchangedFormula().toSMLString(),
//                "([],Pbl)");
//        assertEquals("deleted", cce.getLastDeletedFormula().toSMLString(),
//                "([],Pbl)");
//        assertEquals("generated", cce.getLastGeneratedFormula().toSMLString(),
//                "([],Res)");
//        System.out.println(".end step_c-----");
//        //end step_c
//        // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//
//        //display the steps generated
//        Object fch = null;
//        ci = (ICalcIterator) cce.getLastUnchangedFormula().cloneIterator();
//        int i = 0;
//        ////while (ci.compareTo(cce.getLastGeneratedFormula()) < 0) {
//        //while (i < 10) {
//        //  i++;
//        //  boolean b = ci.moveDown();
//        //  System.out.print("..iterator at " + ci.toSMLString());
//        //  fch = ci.getFormula();
//        //  System.out.println(" yields " + ((ICalcElement) fch).toSMLString());
//        //}
//        Vector<CalcFormula> elems = (cce.getLastUnchangedFormula()).getFormulaeFromTo(
//                cce.getLastGeneratedFormula(), new Integer(/*depth=*/2), false);
//        System.out.println(".in step_d GOON.WN111104");
//
//        for (i = 0; i < elems.size(); i++) {
//            System.out.println(" yields "
//                    + ((ICalcElement) elems.elementAt(i)).toSMLString());
//        }
//        System.out.println("mini-auto: steps= " + i);
//        assertEquals("mini-auto: steps= ", i, 10);
//        //assertEquals("mini-auto: last step", ((ICalcElement) elems.elementAt(i - 1)).toSMLString(), "[x = 1]");
//        System.out.println(".end step_d-----");
//        //end step_d
//        // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//
//        logger_.debug("---END isac.bridge.TestBridge#testMinisubpblAutoCalc");
//        System.out.println("---END isac.bridge.TestBridge#testMinisubpblAutoCalc");
//    }
//
//    /***************************************************************************
//     * tests the example 'IsacCore/Tests/minipbl_with_mini-subpbl' comprising UC
//     * 'start interactive calculation' \label{SPECIFY:START:interactive} +
//     * \label{SOLVE:AUTO:one}}
//     *
//     * step_a like above
//     *
//     * @see TestSolve#testNextButton
//     */
//    public void testMinisubpblNextStep() throws Exception {
//        System.out.println("---BEGIN isac.bridge.TestBridge#testMinisubpblNextStep");
//
//        //load the file of the example,
//        //see TestKEStoreServices#testLoadContentMinisubpbl
//        KEStoreServices ks = new KEStoreServices(TestConstants.KESTORE.XMLDATA_PATH);
//        Vector<String> vec = ks.loadContent("exp", TestConstants.KESTORE.TEST_DATA.EXP_TESTS_1B);
//        //parse out the Formalization
//        //see TestFormalizationDigest#testParseExplMini
//        String xmlstr = (String) vec.firstElement();
//        FormalizationDigest fd = new FormalizationDigest();
//        Formalization fmz = fd.parseFormalization((String) xmlstr);
//        System.out.println(".end step_a-----");
//
//        //start the calculation
//        MathEngine.init("localhost");
//        MathEngine me = MathEngine.getMathEngine();
//
//        IToCalc ct = me.getCalcTree(fmz);
//        IToUser user = new MockIToDialog();
//        ct.addDataChangeListener(user);
//        CalcChanged cce = null;
//        System.out.println(".end step_a-----");
//        //end step_a
//        // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//
//        ct.completeCalcHead();
//        ICalcIterator ci = ct.getActiveFormula();
//        CalcHead ch = (CalcHead) ci.getFormula();
//        System.out.println(".end step_b-----");
//        //end step_b
//        // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//
//        //let calculate the first formula
//        Tactic tac = ct.fetchProposedTactic();
//        //sent to bridge: fetchProposedTactic 1;
//        System.out.println(".2nd tac:" + tac.toSMLString());
//        assertEquals("mini-step: 2nd form", tac.toSMLString(),
//                "Apply_Method [\"Test\",\"squ-equ-test-subpbl1\"]");
//        ct.setNextTactic(tac);
//        //sent to bridge: setNextTactic 1
//        // (Apply_Method["Test","squ-equ-test-subpbl1"]);
//        ct.autoCalculate(IToCalc.SCOPE_CALCULATION, 1);
//
//        cce = ((MockIToDialog) user).getCalcChangedEvent();
//        assertEquals("unchanged", cce.getLastUnchangedFormula().toSMLString(),
//                "([],Met)");
//        assertEquals("deleted", cce.getLastDeletedFormula().toSMLString(),
//                "([],Met)");
//        assertEquals("generated", cce.getLastGeneratedFormula().toSMLString(),
//                "([1],Frm)");
//
//        Vector<CalcFormula> elems = ci.getFormulaeFromTo(cce.getLastGeneratedFormula(),
//                new Integer(2), false);
//        CalcFormula fa = (CalcFormula) (elems.firstElement());
//        System.out.println(".2nd form: " + fa.toSMLString());
//        assertEquals("mini-auto: 2nd form", fa.toSMLString(), "x + 1 = 2");
//
//        System.out.println(".end step_c-----");
//        //end step_c
//        // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//
//        //let calculate the second formula
//        tac = ct.fetchProposedTactic();
//        System.out.println(".3rd tac: " + tac.toSMLString());
//        assertEquals("mini-step: 3rd tac", tac.toSMLString(),
//                "Rewrite_Set \"norm_equation\"");
//
//        ct.setNextTactic(tac);
//        //sent to bridge: autoCalculate 5 (Step 1);
//        ct.autoCalculate(IToCalc.SCOPE_CALCULATION, 1);
//        cce = ((MockIToDialog) user).getCalcChangedEvent();
//        assertEquals("unchanged", cce.getLastUnchangedFormula().toSMLString(),
//                "([1],Frm)");
//        assertEquals("deleted", cce.getLastDeletedFormula().toSMLString(),
//                "([1],Frm)");
//        assertEquals("generated", cce.getLastGeneratedFormula().toSMLString(),
//                "([1],Res)");
//
//        fa = (CalcFormula) (cce.getLastGeneratedFormula()).getElement();
//        System.out.println(".3rd form: " + fa.toSMLString());
//        assertEquals("mini-auto: 3rd form", fa.toSMLString(),
//                "x + 1 + -1 * 2 = 0");
//
//        System.out.println(".end step_d-----");
//        //end step_d
//        // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//
//        //set next a NOT applicable tactis (the one from above)
//        ct.setNextTactic(tac);
//        //cce = ((MockIToDialog) user).getCalcChangedEvent();
//        //.....WN050222 implicit autoCalculate disturbs the following step
//        System.out.println(".end step_e-----");
//        //end step_e
//        // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//    }
//
//    /**
//     * uses the example 'IsacCore/Tests/minipbl_with_mini-subpbl'; comprises the
//     * usecase UC\label{SOLVE:INFO:intermediate-steps} see
//     * smltest/FE-interface/interface.sml "interSteps: on 'miniscript with
//     * mini-subpbl'"
//     *
//     * @see TestSolveEtc#testIntermediateSteps
//     */
//    public void testIntermediateSteps() throws Exception {
//        System.out.println("---BEGIN isac.bridge.TestBridgeInput#testIntermediateSteps");
//
//        //load the file of the example,
//        //see TestKEStoreServices#testLoadContentMinisubpbl
//        KEStoreServices ks = new KEStoreServices(TestConstants.KESTORE.XMLDATA_PATH);
//        Vector<String> vec = ks.loadContent("exp", TestConstants.KESTORE.TEST_DATA.EXP_TESTS_1B);
//        //parse out the Formalization
//        //see TestFormalizationDigest#testParseExplMini
//        String xmlstr = (String) vec.firstElement();
//        FormalizationDigest fd = new FormalizationDigest();
//        Formalization fmz = fd.parseFormalization((String) xmlstr);
//        System.out.println(".end step_a-----");
//
//        //start the calculation
//        MathEngine.init("localhost");
//        MathEngine me = MathEngine.getMathEngine();
//
//        IToCalc ct = me.getCalcTree(fmz);
//        IToUser user = new MockIToDialog();
//        ct.addDataChangeListener(user);
//        CalcChanged cce = null;
//        System.out.println(".end step_a-----");
//        //end step_a
//        // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//
//        ct.autoCalculate(IToCalc.SCOPE_CALCULATION, 0);
//        // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//
//        // intermediateSteps(([2],Res)) gives 6 new steps
//        Position pos = new Position();//([2],Res)
//        pos.addInt("2");
//        pos.setKind("Res");
//        ICalcIterator ci = new CalcIterator((CalcTree) ct, pos);
//
//        ct.intermediateSteps(ci);
//        cce = ((MockIToDialog) user).getCalcChangedEvent();
//        Vector<CalcFormula> elems = cce.getLastUnchangedFormula().getFormulaeFromTo(
//                cce.getLastGeneratedFormula(), new Integer(3), false);
//        CalcFormula fch = null;
//        for (int i = 0; i < elems.size(); i++) {
//            fch = (CalcFormula) elems.elementAt(i);
//            System.out.println(".step " + i + ": "
//                    + ((CalcFormula) fch).getPosition().toSMLString() + " "
//                    + fch.toSMLString());
//        }
//        System.out.println(".-------");
//        assertEquals("mini-auto: steps= ", elems.size(), 7);
//        assertEquals("mini-auto: first step", ((ICalcElement) elems.firstElement()).toSMLString(), "x + 1 + -1 * 2 = 0");
//        assertEquals("mini-auto: last step", ((ICalcElement) elems.lastElement()).toSMLString(), "-1 + x = 0");
//
//        // intermediateSteps(([3,2],Res)) gives 3 new steps
//        pos = new Position();//([3,2],Res)
//        pos.addInt("3");
//        pos.addInt("2");
//        pos.setKind("Res");
//        ci = new CalcIterator((CalcTree) ct, pos);
//
//        ct.intermediateSteps(ci);
//        cce = ((MockIToDialog) user).getCalcChangedEvent();
//        elems = cce.getLastUnchangedFormula().getFormulaeFromTo(
//                cce.getLastGeneratedFormula(), new Integer(3), false);
//        fch = null;
//        for (int i = 0; i < elems.size(); i++) {
//            fch = (CalcFormula) elems.elementAt(i);
//            System.out.println(".step " + i + ": "
//                    + ((CalcFormula) fch).getPosition().toSMLString() + " "
//                    + fch.toSMLString());
//        }
//        System.out.println(".-------");
//        assertEquals("mini-auto: steps= ", elems.size(), 3);
//        assertEquals("mini-auto: first step", ((ICalcElement) elems.firstElement()).toSMLString(), "x = 0 + -1 * -1");
//        assertEquals("mini-auto: last step", ((ICalcElement) elems.lastElement()).toSMLString(), "x = 1");
//
//        // intermediateSteps(([3],Res)) on CalcHead gives NO new steps
//        pos = new Position();//([3],Res)
//        pos.addInt("3");
//        pos.setKind("Res");
//        ci = new CalcIterator((CalcTree) ct, pos);
//
//        ct.intermediateSteps(ci);
//        cce = ((MockIToDialog) user).getCalcChangedEvent();
//        elems = cce.getLastUnchangedFormula().getFormulaeFromTo(
//                cce.getLastGeneratedFormula(), new Integer(1), false);
//        fch = null;
//        for (int i = 0; i < elems.size(); i++) {
//            fch = (CalcFormula) elems.elementAt(i);
//            System.out.println(".step " + i + ": "
//                    + ((CalcFormula) fch).getPosition().toSMLString() + " "
//                    + fch.toSMLString());
//        }
//        System.out.println(".-------");
//        assertEquals("mini-auto: steps= ", elems.size(), 3);
//        assertEquals("mini-auto: first step", ((ICalcElement) elems.firstElement()).toSMLString(), "-1 + x = 0");
//        assertEquals("mini-auto: last step", ((ICalcElement) elems.lastElement()).toSMLString(), "x = 1");
//
//        // intermediateSteps(([],Res)) gives whole calctree (on 1st level)
//        pos = new Position();//([],Res)
//        pos.setKind("Res");
//        ci = new CalcIterator((CalcTree) ct, pos);
//
//        ct.intermediateSteps(ci);
//        cce = ((MockIToDialog) user).getCalcChangedEvent();
//        elems = cce.getLastUnchangedFormula().getFormulaeFromTo(
//                cce.getLastGeneratedFormula(), new Integer(1), false);
//        fch = null;
//        for (int i = 0; i < elems.size(); i++) {
//            fch = (CalcFormula) elems.elementAt(i);
//            System.out.println(".step " + i + ": "
//                    + ((CalcFormula) fch).getPosition().toSMLString() + " "
//                    + fch.toSMLString());
//        }
//        assertEquals("mini-auto: steps= ", elems.size(), 6);
//        assertEquals("mini-auto: first step", ((ICalcElement) elems.firstElement()).toSMLString(), "x + 1 = 2");
//        assertEquals("mini-auto: last step", ((ICalcElement) elems.lastElement()).toSMLString(), "[x = 1]");
//    }

    /**
     * uses the example 'IsacCore/Tests/minipbl_with_mini-subpbl'; comprises the
     * UC\label{SOLVE:HIDE:getTactic} and UC\label{SOLVE:MANUAL:TACTIC:listall}
     * see smltest/FE-interface/interface.sml '- getTactic, fetchApplicableTactics -'
     */
    public void testTactics() throws Exception {
        System.out.println("---BEGIN isac.bridge.TestBridge#testTactics");

        //load the file of the example,
        //see TestKEStoreServices#testLoadContentMinisubpbl
        KEStoreServices ks = new KEStoreServices(TestConstants.KESTORE.XMLDATA_PATH);
        Vector<String> vec = ks.loadContent("exp", "exp_IsacCore_Tests_1b.xml");
        //parse out the Formalization
        //see TestFormalizationDigest#testParseExplMini
        String xmlstr = (String) vec.firstElement();
        FormalizationDigest fd = new FormalizationDigest();
        Formalization fmz = fd.parseFormalization((String) xmlstr);
        System.out.println(".end step_a-----");

        //start the calculation
        MathEngine.init("localhost");
        MathEngine me = MathEngine.getMathEngine();

        IToCalc ct = me.getCalcTree(fmz);
        IToUser user = new MockIToDialog();
        ct.addDataChangeListener(user);
        @SuppressWarnings("unused") // used in outcommented code
        CalcChanged cce = null;
        System.out.println(".end step_a-----");
        //end step_a
        // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

        ct.autoCalculate(IToCalc.SCOPE_CALCULATION, 0);
        // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

        // on (root) CalcHead: also with getApplicableTactics only one Tactic
        Position pos = new Position();//([],Pbl)
        pos.setKind("Pbl");
        ICalcIterator ci = new CalcIterator((CalcTree) ct, pos);

        Tactic tac = ci.getTactic();// <--------------------------------
        assertEquals("at ([],Pbl) found: ", ((Tactic) tac).toSMLString(),
                "Apply_Method [\"Test\",\"squ-equ-test-subpbl1\"]");

		Vector<Tactic> tacs = ci.getApplicableTactics(99999);// <---------------
        assertEquals(((Tactic) tacs.firstElement()).toSMLString(),
                "Apply_Method [\"Test\",\"squ-equ-test-subpbl1\"]");
        assertEquals("number of appl. tacs = ", tacs.size(), 1);

        // somewhere in rootproblem: all Tactics in the method
        pos = new Position();//([1],Res)
        pos.addInt("1");
        pos.setKind("Res");
        ci = new CalcIterator((CalcTree) ct, pos);

        tac = ci.getTactic();// <---------------------------------------
        assertEquals(tac.toSMLString(), "Rewrite_Set \"Test_simplify\"");

        tacs = ci.getApplicableTactics(99999);// <----------------------
        System.out.println(".at " + ci.toSMLString() + ":");
        for (int i = 0; i < tacs.size(); i++) {
            System.out.println(".." + ((Tactic) tacs.get(i)).toSMLString());
        }
        assertEquals("number of appl. tacs = ", tacs.size(),
                /*3 ..fetchApplicableTactics vers.2*/4);

        // on CalcHead of subproblem: only Apply_Method
        pos = new Position();//([3],Pbl)
        pos.addInt("3");
        pos.setKind("Pbl");
        ci = new CalcIterator((CalcTree) ct, pos);

        tac = ci.getTactic();// <---------------------------------------
        assertEquals(tac.toSMLString(),
                "Apply_Method [\"Test\",\"solve_linear\"]");

        tacs = ci.getApplicableTactics(99999);// <----------------------
        assertEquals("at ([3],Pbl) found: ", ((Tactic) tacs.firstElement()).toSMLString(), "Apply_Method [\"Test\",\"solve_linear\"]");
        assertEquals("number of appl. tacs = ", tacs.size(), 1);

        // somewhere in subproblem: all Tactics in this (other) method
        pos = new Position();//([3,1],Res)
        pos.addInt("3");
        pos.addInt("1");
        pos.setKind("Res");
        ci = new CalcIterator((CalcTree) ct, pos);

        tac = ci.getTactic();// <---------------------------------------
        assertEquals(tac.toSMLString(), "Rewrite_Set \"Test_simplify\"");

        tacs = ci.getApplicableTactics(99999);// <----------------------
        System.out.println(".at " + ci.toSMLString() + ":");
        for (int i = 0; i < tacs.size(); i++) {
            System.out.println(".." + ((Tactic) tacs.get(i)).toSMLString());
        }
        assertEquals("at ([3,1],Res) found: ", tacs.size(),
                /*3 ..fetchApplicableTactics vers.2*/2);

        // on the result of the subproblem again all tacs of the rootpbl
        pos = new Position();//([3],Res)
        pos.addInt("3");
        pos.setKind("Res");
        ci = new CalcIterator((CalcTree) ct, pos);

        tac = ci.getTactic();// <---------------------------------------
        System.out.println("tac = " + tac.toSMLString());
        /*PIDE*/assertEquals(tac.toSMLString(), "Check_elementwise Assumptions");
        //*TTY*/assertEquals(tac.toSMLString(), "Check_elementwise \"Assumptions\"");
        tacs = ci.getApplicableTactics(99999);// <----------------------
        System.out.println(".at " + ci.toSMLString() + ":");
        for (int i = 0; i < tacs.size(); i++) {
            System.out.println(".." + ((Tactic) tacs.get(i)).toSMLString());
        }
        assertEquals("at ([3],Res) found: ", tacs.size(),
                /*1 ..fetchApplicableTactics vers.2*/4);

        // but on the final result there are _NO_ tacs applicable
        pos = new Position();//([],Res)
        pos.setKind("Res");
        ci = new CalcIterator((CalcTree) ct, pos);
        // tac = ci.getTactic();// <------------------------------------
        // tacs = ci.getApplicableTactics(99999);// <-------------------
        // TODO handle error msg
    }

//    /**
//     * uses the example 'IsacCore/Tests/rat.equ, asms'; comprises the usecases
//     * UC\label{SOLVE:HELP:assumptions} and
//     * *UC\label{SOLVE:HELP:assumptions-origin} smltest/FE-interface/interface.sml '-
//     * getAssumptions, getAccumulatedAsms -'
//     */
//    public void testAssumptions() throws Exception {
//        System.out.println("---BEGIN isac.bridge.TestBridge#testAssumptions");
//
//        //load the file of the example,
//        //see TestKEStoreServices#testLoadContentMinisubpbl
//        KEStoreServices ks = new KEStoreServices(TestConstants.KESTORE.XMLDATA_PATH);
//        Vector<String> vec = ks.loadContent("exp", TestConstants.KESTORE.TEST_DATA.EXP_TEST_1C);
//        //parse out the Formalization
//        //see TestFormalizationDigest#testParseExplMini
//        String xmlstr = (String) vec.firstElement();
//        FormalizationDigest fd = new FormalizationDigest();
//        Formalization fmz = fd.parseFormalization((String) xmlstr);
//        System.out.println(".end step_a-----");
//
//        //start the calculation
//        MathEngine.init("localhost");
//        MathEngine me = MathEngine.getMathEngine();
//
//        IToCalc ct = me.getCalcTree(fmz);
//        IToUser user = new MockIToDialog();
//        ct.addDataChangeListener(user);
//        CalcChanged cce = null;
//        System.out.println(".end step_a-----");
//        //end step_a
//        // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//
//        ct.autoCalculate(IToCalc.SCOPE_CALCULATION, 0);
//
//        //		for (int i = 0; i < forms.size(); i++)
//        //			System.out.println(".asm= "
//        //					+ ((Formula) forms.elementAt(i)).toSMLString());
//
//        // here the assumption arises
//        Position pos = new Position();//([3],Res)
//        pos.addInt("3");
//        pos.setKind("Res");
//        CalcIterator ci = new CalcIterator((CalcTree) ct, pos);
//
//        Assumptions asm = ci.getAssumptions();//<---------------------------
//        Vector<Formula> forms = asm.getFormulae();
//        assertEquals("asm generated here:", ((Formula) forms.firstElement()).toSMLString(),
//                  "9 * x + -6 * x ^ 2 + x ^ 3 ~= 0");
//        asm = ci.getAccumulatedAssumptions();//<----------------------------
//        forms = asm.getFormulae();
//        assertEquals("is the only asm:", ((Formula) forms.firstElement()).toSMLString(),
//                  "9 * x + -6 * x ^ 2 + x ^ 3 ~= 0");
//
//        // here the assumption is checked
//        pos = new Position();//([5],Res)
//        pos.addInt("5");
//        pos.setKind("Res");
//        ci = new CalcIterator((CalcTree) ct, pos);
//
//        asm = ci.getAssumptions();//<---------------------------------------
//        forms = asm.getFormulae();
//        assertEquals("here no asm generated:", forms.size(), 0);
//        asm = ci.getAccumulatedAssumptions();//<----------------------------
//        forms = asm.getFormulae();
//        //assertEquals("acumulated from above:", ((Formula) forms.firstElement()).toSMLString(),
//        //"9 * x + -6 * x ^ 2 + x ^ 3 ~= 0");  before ctxt in Isabelle2011
//        assertEquals("acumulated from above:", ((Formula) forms.firstElement()).toSMLString().replace("\n", ""),
//          "~ matches (?a = 0)   ((3 + -1 * x + x ^ 2) * x = 1 * (9 * x + -6 * x ^ 2 + x ^ 3)) "
//          + "|~ lhs ((3 + -1 * x + x ^ 2) * x =       "
//          + "1 * (9 * x + -6 * x ^ 2 + x ^ 3)) is_poly_in x");
//        System.out.println("---END isac.bridge.TestBridge");
//    }
}