/*
 * @author Walther Neuper, member of the ISAC-team, 
 * Copyright (c) 2004 by Walther Neuper 
 * created Oct 1, 2004, 1:33:36 PM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to license terms.
 */
package isac.bridge;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

/**
 * Collect the testcases and testsuites from this directory
 * and from the subdirectories
 * @author Walther Neuper Oct 1, 2004, 3:44:31 PM
 * @version 1.0
 **/
public class Testall extends TestCase {

	public static Test suite() {
		System.out.println("/--BEGIN isac.bridge.Testall");
		TestSuite suite = new TestSuite("isac.bridge.Testall");
		
		//first test the connection to Isabelle/Isac
		suite.addTestSuite(isac.bridge.TestPIDE.class);    //.....................vvv
		
		//tests from subdirectories
        suite.addTest(isac.bridge.xml.Testall.suite());
		
		//tests in this directory
		//Isabelle_Isac       ...NOT a JUnit TestCase, re-usable connection
		//MockIToDialog       ...NOT a JUnit TestCase, mock
		//RGtestCalcTree      ...NOT a JUnit TestCase
		//RGtestTransformXSLT ...NOT a JUnit TestCase
		suite.addTestSuite(isac.bridge.TestBridge.class);
		suite.addTestSuite(isac.bridge.TestBridgeInput.class);
		suite.addTestSuite(isac.bridge.TestContext.class);
		//suite.addTestSuite(isac.bridge.TestModel.class);   ...since PIDE
		//suite.addTestSuite(isac.bridge.TestPIDE.class);    ... done first above ^^^
		//suite.addTestSuite(isac.bridge.TestSpecify.class); ...since PIDE
		//suite.addTestSuite(isac.bridge.TestTerm.class);   ...TODO: problem with new Properties()
		
        System.out.println("\\--END   isac.bridge.Testall");
		return suite;
	}
}
