/*
 * @author Walther Neuper
 * Copyright (c) due to license terms
 * Created on Aug 18, 2015
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 */
package isac.bridge.xml;

import isac.bridge.xml.TestsDATA; // DataTypes.scala
import info.hupel.isabelle.api.XML;
import junit.framework.TestCase;

/**
 * @author Walther Neuper Aug 18, 2015
 * TODO
 */
public class TestXMLout extends TestCase {

  /* test_is_message failed, so we prepare by increasing complexity stepwise:
   * 1:   def create_AAA (): XML.Tree = XML.Elem(Markup("AAA", Nil), Nil)
   */
  public void test_match() throws Exception {
    System.out.println("  ---------------------------------------------");
    System.out.println("/--BEGIN isac.bridge.xml.TestXMLout#test_match");

    XML.Tree xml_out = TestsDATA.create_AAA();
    String found = TestsDATA.match_ABC(xml_out);
    assertEquals("case simplest", found, "AAA");

    xml_out = TestsDATA.create_BBB();
    found = TestsDATA.match_ABC(xml_out);
    assertEquals("case 2nd match", found, "BBB");

    xml_out = TestsDATA.create_CCCddd();
    found = TestsDATA.match_ABC(xml_out);
    assertEquals("case 2 fields", found, "CCCddd");

    xml_out = TestsDATA.create_DDDeeeFFF();
    found = TestsDATA.match_ABC(xml_out);
    assertEquals("case 3 fields", found, "DDDeeeFFF");

    xml_out = TestsDATA.create_EEEfffGGGhhhIII();
    found = TestsDATA.match_ABC(xml_out);
    assertEquals("case 5 fields", found, "EEEfffGGGhhhIII");

    xml_out = TestsDATA.create_SYSERROR();
    found = TestsDATA.match_ABC(xml_out);
    assertEquals("case SYSERROR, XML.Text(\"1\") ANDALSO XML.Text(_)", found, "SYSERROR");

    System.out.println("\\--END isac.bridge.xml.TestXMLout#test_match");

  }
  
  /* found wrong () in IsaToJava.is_message */
  public void test_is_message() throws Exception {
	System.out.println("  ---------------------------------------------");
	System.out.println("/--BEGIN isac.bridge.xml.TestXMLout#test_is_message");

	XML.Tree xml_out = TestsDATA.create_SYSERROR();
	Boolean is_msg = IsaToJava.is_message(xml_out);
	assertTrue("<SYSERROR>... is recognised as a message.", is_msg);
	        
	System.out.println("\\--END isac.bridge.xml.TestXMLout#test_is_message");

	}
}