/*
 * @author ////Walther Neuper, member of the ISAC-team, 
 * Copyright (c) 2005 by Walther Neuper
 * created Aug 8, 2005 4:37:59 PM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to PGPL license terms.
 */
package isac.browserdialog;

import java.rmi.RemoteException;

import isac.gui.util.Hierarchy;
import isac.interfaces.IToGUI;
import isac.useractions.EUIContext;
import isac.useractions.EUIElement;
import isac.useractions.IUIAction;
import isac.useractions.IUserAction;
import isac.useractions.UIActionOnLink;
import isac.useractions.UIActionOnHierarchy;

/**
 * To test the basic functions of the ProblemBrowserDialog
 *
 *  @author Johannes Loinig
 * @version $Revision: 1.6 $
 * 
 */
public class MockProblemBrowserFrame implements IToGUI{

	public Hierarchy hierarchy_ = null;
	
	public Boolean auto_match_mode_off_ = null;
	
	public Boolean auto_match_mode_on_ = null;
	
	public String link_ = null;
	
    /* (non-Javadoc)
     * @see isac.interfaces.IToGUI#activateUIObject(int, boolean)
     */
    public void activateUIObject(int id, boolean active) throws RemoteException {
        // TODO Auto-generated method stub
        
    }

    /**
     * @deprecated
     * @see isac.interfaces.IToGUI#doUIAction(isac.useractions.IUserAction)
     */
    public boolean doUIAction(IUserAction action) throws RemoteException {
        // TODO Auto-generated method stub
        return false;
    }

    /* (non-Javadoc)
     * @see isac.interfaces.IToGUI#doUIAction(isac.useractions.IUIAction)
     */
    public void doUIAction(IUIAction action) throws RemoteException {
    	
    	if(action.getAction() == EUIElement.UI_REQUEST_FOR_HIERARCHY &&
    			action.getContext() == EUIContext.UI_CONTEXT_BROWSER_PANEL) {
    		hierarchy_ = ((UIActionOnHierarchy)action).getHierarchy();
    		return;
    	}
    	
    	if(action.getAction() == EUIElement.UI_MINIBROWSER_LINK &&
    			action.getContext() == EUIContext.UI_CONTEXT_MINIBROWSER) {
    		link_ = ((UIActionOnLink)action).getLink().toString();
    		return;
    	}
     }

    /* (non-Javadoc)
     * @see isac.interfaces.IToGUI#addUIElement(isac.useractions.IUIAction)
     */
    public void addUIElement(IUIAction action) throws RemoteException {
       	if(action.getAction() == EUIElement.UI_PROBLEMBROWSER_AUTO_MATCH_ON &&
    			action.getContext() == EUIContext.UI_CONTEXT_BROWSER) {
    		auto_match_mode_on_ = new Boolean(true);
    		return;
    	}
    }

    /* (non-Javadoc)
     * @see isac.interfaces.IToGUI#removeUIElement(isac.useractions.IUIAction)
     */
    public boolean removeUIElement(IUIAction action) throws RemoteException {
    	if(action.getAction() == EUIElement.UI_PROBLEMBROWSER_AUTO_MATCH_OFF &&
    			action.getContext() == EUIContext.UI_CONTEXT_BROWSER) {
    		auto_match_mode_off_ = new Boolean(true);
    		return true;
    	}
        return false;
    }

	public boolean isUIRunning() throws RemoteException {
		// TODO Auto-generated method stub
		return false;
	}

}
