/*
 * @author Walther Neuper, member of the ISAC-team, 
 * Copyright (c) 2004 by Walther Neuper 
 * created Oct 1, 2004, 4:22:25 PM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to license terms.
 */
package isac.functest;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

/**
 * Collect the testcases and testsuites from this directory
 * and from the subdirectories
 * @author Walther Neuper Oct 1, 2004, 3:44:31 PM
 * @version 1.0
 **/
public class Testall extends TestCase {

	public static Test suite() {
		System.out.println("/--BEGIN isac.functest.Testall");
		TestSuite suite = new TestSuite("isac.functest.Testall");

		//tests in subdirectories
		suite.addTest(isac.functest.calcsteps.Testall.suite());
		//                 context  ... no JUnit TestCase, but *.html, *.xml
		suite.addTest(isac.functest.examples.Testall.suite());
		suite.addTest(isac.functest.problems.Testall.suite());
		suite.addTest(isac.functest.specify.Testall.suite());
		suite.addTest(isac.functest.start.Testall.suite());
		
		//tests in this directory
		//...
		
	    System.out.println("\\--END   isac.functest.Testall");
		return suite;
	}
}
