/*
 * @author Walther Neuper, member of the ISAC-team, 
 * Copyright (c) 2004 by Walther Neuper 
 * created June 1, 2005
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to license terms.
 */
package isac.functest.specify;

import isac.functest.specify.TestModel;
import isac.functest.specify.TestSpecify;
import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

/**
 * Collect the testcases and testsuites from this directory
 * and from the subdirectories
 * @author Walther Neuper Oct 1, 2004, 3:44:31 PM
 * @version 1.0
 **/
public class Testall extends TestCase {

	public static Test suite() {
		System.out.println("/--BEGIN isac.functest.specify.Testall");
		TestSuite suite = new TestSuite("isac.functest.specify.Testall");
		
		//tests in subdirectories
		//...
		
		//tests in this directory
		suite.addTestSuite(TestModel.class);
		suite.addTestSuite(TestSpecify.class);
		suite.addTestSuite(TestCalculation.class);
		suite.addTestSuite(TestHierarchy.class);

	    System.out.println("\\--END   isac.functest.specify.Testall");
		return suite;
	}
}
