/****************************************************************** 
* Copyright (c) 2004, Alois Kirchsteiger, Student of 
* Software Engineering at FH-Hagenberg, Austria. 
* Project member of the isac team at the Institute for 
* Software-Technologie, Graz University of Technology, Austria. 
* 
* Use is subject to license terms.
******************************************************************/

package isac.gui;

/**
 * @author Alois Kirchsteiger
 * Mock class to test the function of the class 
 * <code>LoginScreen</code> which should inform registered
 * ILoginListeners about login and exit user action
 */
public class MockLoginListener implements ILoginListener {
	
	private static final long serialVersionUID = 1L;
	
	LoginEvent lastLoginEvent;
	
	public MockLoginListener() {
		lastLoginEvent = null;
	}
	
	public LoginEvent getLastLoginEvent() {
		return lastLoginEvent;
	}
	
	/* (non-Javadoc)
	 * @see isac.gui.ILoginListener#loginEventOccured(isac.gui.LoginEvent)
	 */
	public void loginEventOccured(LoginEvent loginEvent) {
		this.lastLoginEvent = loginEvent;
	}

}
