/*
 * @author Walther Neuper, member of the ISAC-team, 
 * Copyright (c) 2004 by Walther Neuper 
 * created Oct 1, 2004, 3:59:37 PM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to license terms.
 */
package isac.gui;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;
import junit.textui.TestRunner;

/**
 * Collect the testcases and testsuites from this directory
 * and from the subdirectories
 * @author Walther Neuper Oct 1, 2004, 3:44:31 PM
 * @version 1.0
 **/
public class Testall extends TestCase {

	protected void setUp() throws Exception {
		super.setUp();
		//WN041001 kam mit __________________ nicht zurecht
		TestRunner.run(Testall.class);
	}
	
	public static Test suite() {
		System.out.println("/--BEGIN isac.gui.Testall");
		TestSuite suite = new TestSuite("isac.gui.Testall");
		
		//tests in subdirectories
		suite.addTest(isac.gui.browser.Testall.suite());
		suite.addTest(isac.gui.calcheadviews.Testall.suite());
		suite.addTest(isac.gui.mawen.Testall.suite());
		suite.addTest(isac.gui.treetable.Testall.suite());
		
		//tests in this directory
	    //suite.addTestSuite(TestLoginScreen.class); ... // since PIDE
	    suite.addTestSuite(TestWindowApplication.class);
	    //suite.addTestSuite(TestWindowApplicationJFCUnit.class);
	    suite.addTestSuite(TestWindowApplicationMini.class);
	    suite.addTestSuite(TestWindowApplicationStub.class);
	    //                 WorksheetStub   ... is NOT a JUnit TestCase
	    //                 WorksheetSwing  ... is NOT a JUnit TestCase

	    System.out.println("\\--END   isac.gui.Testall");
		return suite;
	}
}
