/*
 * Created on 08.07.2005
 *
 * TOODO JL: more testcases for the MiniBrowser
 */
package isac.gui.browser.minibrowser;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.io.IOException;

import junit.framework.TestCase;

/**
 * MiniBrowser
 * 
 * This testcases should test the MiniBrowser independend from the
 * implementation. So only functional use cases are tested.
 * 
 * All tests have to be done after each other (synchronized). The MiniBrowser
 * throws an event if the browser contend is updated. This is signalized with
 * the page_update_event_ flag. Then the assertion can be done. Therefore this
 * class is implemented as event listender.
 * 
 * @author JL
 * @version $Revision: 1.10 $
 * @see isac.gui.browser.minibrowser.IMiniBrowser
 * @see isac.gui.browser.minibrowser.MiniBrowser
 *  
 */
public class TestMiniBrowser extends TestCase implements PropertyChangeListener {

	@SuppressWarnings("unused") // is used below; deletion causes error
	private boolean page_update_event_ = false;
	
	/*
	 * testNewMiniBrowserWithLocalPage
	 * 
	 * Tests the generation of a MiniBrowser and the representation of a local
	 * (isac internal) page (problem, excample, ...)
	 * 
	 * @author Johannes Loinig
	 */
	public synchronized void testNewMiniBrowserWithLocalPage() throws IOException {
		
//FK		System.out
//FK				.println("---BEGIN isac.functest.minibrowser.testNewMiniBrowserWithLocalPage");
//FK
//FK		//IBrowserDialog dialog = (IBrowserDialog) new ExampleDialog(new Session("dummy"));
//FK		MockProxy proxy_mock = new MockProxy(null);
//FK		MiniBrowser mini_browser = new MiniBrowser(proxy_mock);
//FK		
//FK		UIActionOnLink action = new UIActionOnLink(
//FK				EUIElement.UI_MINIBROWSER_LINK,
//FK				EUIContext.UI_CONTEXT_CONTENT, null,
//FK                MINIBROWSER.TEST_HTML);
//FK
//FK		this.page_update_event_ = false;
//FK		mini_browser.addPropertyChangeListener(this);
//FK		mini_browser
//FK			.doUIAction(action);
//FK
//FK		while(!this.page_update_event_);
//FK
//FK		String result = mini_browser.getText();
//FK		String result_first_line = result.substring(0, result.indexOf("\n"));
//FK		String expected_first_line = "<html math=\"http://www.w3.org/1998/Math/MathML\" xlink=\"http://www.w3.org/1999/xlink\" xmlns=\"#DEFAULT\">";
//FK		
//FK		assertEquals(expected_first_line, result_first_line);
//FK		assertEquals(MINIBROWSER.TEST_HTML,	new File(mini_browser.getPage().getFile()).toURL());
//FK		
//FK		System.out.println("---END isac.functest.minibrowser.testNewMiniBrowserWithLocalPage");
	}

	/*
	 * testKlickOnLink
	 * 
	 * Tests if the right action is sent when a link is klicked.
	 * @author Johannes Loinig
	 */
	public synchronized void testKlickOnLink() throws IOException {
	
//FK		System.out.println("---BEGIN isac.functest.minibrowser.testKlickOnLink");
//FK
//FK		//IBrowserDialog dialog = (IBrowserDialog) new ExampleDialog(new Session("dummy"));
//FK		MockProxy proxy_mock = new MockProxy(null);
//FK		MiniBrowser mini_browser = new MiniBrowser(proxy_mock);
//FK		mini_browser.addPropertyChangeListener(this);
//FK
//FK		this.page_update_event_ = false;
//FK		mini_browser.setPage(MINIBROWSER.TEST_HTML);
//FK        
//FK		while(!this.page_update_event_);
//FK
//FK		this.page_update_event_ = false;
//FK
//FK		HyperlinkEvent hyperlink_event = new HyperlinkEvent(mini_browser,
//FK				HyperlinkEvent.EventType.ACTIVATED, MINIBROWSER.TEST2_HTML);
//FK		
//FK		mini_browser.fireHyperlinkUpdate(hyperlink_event);
//FK
//FK		assertEquals("No Event fired.", proxy_mock.hyperlink_event_fired_, true);
//FK
//FK		assertEquals(MINIBROWSER.TEST2_HTML.toExternalForm(), proxy_mock.link_);
//FK
//FK		System.out.println("---END isac.functest.minibrowser.testKlickOnLink");
	}

	/* 
	 * Catches the PropertyChangeEvent of the MiniBrowser.
	 * 
	 * @see java.beans.PropertyChangeListener#propertyChange(java.beans.PropertyChangeEvent)
	 * 
	 * @param property_change_event the Event to be catched
	 */
	public void propertyChange(PropertyChangeEvent property_change_event) {
		System.out.println("huhuhu");
		System.out.println("string"+property_change_event.getPropertyName());
		if(property_change_event.getPropertyName().equals("page")) {
			this.page_update_event_ = true;
		}
	}

}