package isac.gui.mawen;

import isac.gui.mawen.scalaterm.TestsDATA;
import isac.gui.mawen.syntax.Syntax_Phases;
import isac.util.formulae.CalcFormula;
import isac.util.formulae.Formula;
import isac.util.formulae.Position;

import java.util.Vector;

/*
 * a specific calculation ("example for reference")
 * for retrieval by <code>MockDialogIteratorSIMPLIFY</code>.
 */
public class MockCalcTree {

	Vector<CalcFormula> calc_tree_ = new Vector<CalcFormula>();
	
	// uncomment one of the calculations below
	public MockCalcTree() {
	  //buildTestTree();
	  // buildEvalTreeScen1();
	  // buildEvalTreeScen4();
	  // buildEvalTreeScen5();
	  buildtestUC_userguide();

    
	}
private void buildEvalTreeScen5() {
  Vector<Integer> p = new Vector<Integer>();
  Position pos = new Position(p, "Pbl");
  Formula form = new Formula("1+((2*x*(y+3)+((y^2+6*y+9)/(y+3)))/(4*z*(y+3)))+(5::real)", 
/*err*/Syntax_Phases.term_to_ast(TestsDATA.tt_me5_1()));
  calc_tree_.add(new CalcFormula(pos, form));

  // getFormulaeFromTo will need ([],Met):
  p = new Vector<Integer>();
  pos = new Position(p, "Met");
  form = new Formula("1+((2*x*(y+3)+((y^2+6*y+9)/(y+3)))/(4*z*(y+3)))+(5::real)", 
/*err*/Syntax_Phases.term_to_ast(TestsDATA.tt_me5_1()));
  calc_tree_.add(new CalcFormula(pos, form));

  //-->ISA: getFormulaeFromTo 1 ([],Met) ([1],Frm) 0 false;
  //<--ISA: "1 + (2 * x * (y + 3)) / (4 * z * (y + 3)) + 5"
  p = new Vector<Integer>(); p.add(1);
  pos = new Position(p, "Frm");
  form = new Formula("1+((2*x*(y+3)+(((y+3)^2)/(y+3)))/(4*z*(y+3)))+(5::real)", 
/*err*/Syntax_Phases.term_to_ast(TestsDATA.tt_me5_2()));
  calc_tree_.add(new CalcFormula(pos, form));

  //-->ISA: getFormulaeFromTo 1 ([1],Frm) ([1],Res) 0 false;
  //<--ISA: "1 + (2 * x) / (4 * z) + 5"
  p = new Vector<Integer>(); p.add(1);
  pos = new Position(p, "Res");
  form = new Formula("1+(((2*x*(y+3))+(y+3))/(4*z*(y+3)))+(5::real)", 
/*err*/Syntax_Phases.term_to_ast(TestsDATA.tt_me5_3()));
  calc_tree_.add(new CalcFormula(pos, form));

  //-->ISA: getFormulaeFromTo 1 ([1],Res) ([2],Res) 0 false;
  //<--ISA: "1 + x / (2 * z) + 5"
  p = new Vector<Integer>(); p.add(2);
  pos = new Position(p, "Res");
  form = new Formula("1+(((2*x+1)*(y+3))/(4*z*(y+3)))+(5::real)", 
/*err*/Syntax_Phases.term_to_ast(TestsDATA.tt_me5_4()));
  calc_tree_.add(new CalcFormula(pos, form));

  //-->ISA: getFormulaeFromTo 1 ([2],Res) ([3],Res) 0 false;
  //<--ISA: "6 + x / (2 * z)"
  p = new Vector<Integer>(); p.add(3);
  pos = new Position(p, "Res");
  form = new Formula("1+((2*x+1)/(4*z))+(5::real)", 
/*err*/Syntax_Phases.term_to_ast(TestsDATA.tt_me5_5()));
  calc_tree_.add(new CalcFormula(pos, form));
  
  p = new Vector<Integer>(); p.add(4);
  pos = new Position(p, "Res");
  form = new Formula("6+((2*x+1)/(4*(z::real)))", 
/*err*/Syntax_Phases.term_to_ast(TestsDATA.tt_me5_6()));
  calc_tree_.add(new CalcFormula(pos, form));
  }

@SuppressWarnings("unused") // used for mocking CalcTree
private void buildEvalTreeScen4() {
  Vector<Integer> p = new Vector<>();
  Position pos = new Position(p, "Pbl");
  Formula form = new Formula("6+(((1+3*b)*(2+a))/(4*c*(2+(a::real))))", 
/*err*/Syntax_Phases.term_to_ast(TestsDATA.tt_me4_1()));
  calc_tree_.add(new CalcFormula(pos, form));
  
  // getFormulaeFromTo will need ([],Met):
  p = new Vector<Integer>();
  pos = new Position(p, "Met");
  form = new Formula("6+(((1+3*b)*(2+a))/(4*c*(2+(a::real))))", 
/*err*/Syntax_Phases.term_to_ast(TestsDATA.tt_me4_1()));
  calc_tree_.add(new CalcFormula(pos, form));
  
  //-->ISA: getFormulaeFromTo 1 ([],Met) ([1],Frm) 0 false;
  //<--ISA: "1 + (2 * x * (y + 3)) / (4 * z * (y + 3)) + 5"
  p = new Vector<Integer>(); p.add(1);
  pos = new Position(p, "Frm");
  form = new Formula("6+(((((2+a)^2)/(2+a))+3*b*(2+a))/(4*c*(2+(a::real))))", 
/*err*/Syntax_Phases.term_to_ast(TestsDATA.tt_me4_2()));
  calc_tree_.add(new CalcFormula(pos, form));
    
  //-->ISA: getFormulaeFromTo 1 ([1],Frm) ([1],Res) 0 false;
  //<--ISA: "1 + (2 * x) / (4 * z) + 5"
  p = new Vector<Integer>(); p.add(1);
  pos = new Position(p, "Res");
  form = new Formula("5+((((4+4*a+a^2)/(2+a))+3*b*(2+a))/((4*c*(2+a))))+(1::real)", 
/*err*/Syntax_Phases.term_to_ast(TestsDATA.tt_me4_3()));
  calc_tree_.add(new CalcFormula(pos, form));    
  }

@SuppressWarnings("unused") // used for mocking CalcTree
private void buildEvalTreeScen1() {
  Vector<Integer> p = new Vector<Integer>();
  Position pos = new Position(p, "Pbl");
  Formula form = new Formula("1+((2*x*(y+3)+((y^2+6*y+9)/(y+3)))/(4*z*(y+3)))+(5::real)", 
/*err*/Syntax_Phases.term_to_ast(TestsDATA.tt_me1_1()));
  calc_tree_.add(new CalcFormula(pos, form));
  
  // getFormulaeFromTo will need ([],Met):
  p = new Vector<Integer>();
  pos = new Position(p, "Met");
  form = new Formula("1+((2*x*(y+3)+((y^2+6*y+9)/(y+3)))/(4*z*(y+3)))+(5::real)", 
/*err*/Syntax_Phases.term_to_ast(TestsDATA.tt_me1_1()));
  calc_tree_.add(new CalcFormula(pos, form));
  
  //-->ISA: getFormulaeFromTo 1 ([],Met) ([1],Frm) 0 false;
  //<--ISA: "1 + (2 * x * (y + 3)) / (4 * z * (y + 3)) + 5"
  p = new Vector<Integer>(); p.add(1);
  pos = new Position(p, "Frm");
  form = new Formula("1+((2*x*(y+3)+(((y+3)^2)/(y+3)))/(4*z*(y+3)))+(5::real)", 
/*err*/Syntax_Phases.term_to_ast(TestsDATA.tt_me1_2()));
  calc_tree_.add(new CalcFormula(pos, form));
    
  //-->ISA: getFormulaeFromTo 1 ([1],Frm) ([1],Res) 0 false;
  //<--ISA: "1 + (2 * x) / (4 * z) + 5"
  p = new Vector<Integer>(); p.add(1);
  pos = new Position(p, "Res");
  form = new Formula("6+((2*(x+1)*(y+3))/(4*z*(y+(3::real))))", 
/*err*/Syntax_Phases.term_to_ast(TestsDATA.tt_me1_3()));
  calc_tree_.add(new CalcFormula(pos, form));
  }

private void buildtestUC_userguide() {

  Vector<Integer> p = new Vector<>();
  Position pos = new Position(p, "Pbl");
  Formula form = new Formula("xxx)", 
/*err*/    (isac.gui.mawen.TestDATA.ast_05()));
  calc_tree_.add(new CalcFormula(pos, form));

  // getFormulaeFromTo will need ([],Met):
  p = new Vector<Integer>();
  pos = new Position(p, "Met");
  form = new Formula("xxx", 
/*err*/    (isac.gui.mawen.TestDATA.ast_05()));
  calc_tree_.add(new CalcFormula(pos, form));

  //-->ISA: getFormulaeFromTo 1 ([],Met) ([1],Frm) 0 false;
  //<--ISA: "1 + (2 * x * (y + 3)) / (4 * z * (y + 3)) + 5"
  p = new Vector<Integer>(); p.add(1);
  pos = new Position(p, "Frm");
  form = new Formula("yyy", 
/*err*/    (isac.gui.mawen.TestDATA.ast_06()));
  calc_tree_.add(new CalcFormula(pos, form));

  //-->ISA: getFormulaeFromTo 1 ([1],Frm) ([1],Res) 0 false;
  //<--ISA: "1 + (2 * x) / (4 * z) + 5"
  p = new Vector<Integer>(); p.add(1);
  pos = new Position(p, "Res");
  form = new Formula("zzz", 
/*err*/    (isac.gui.mawen.TestDATA.ast_07()));
  calc_tree_.add(new CalcFormula(pos, form));

  //-->ISA: getFormulaeFromTo 1 ([1],Res) ([2],Res) 0 false;
  //<--ISA: "1 + x / (2 * z) + 5"
  p = new Vector<Integer>(); p.add(2);
  pos = new Position(p, "Res");
  form = new Formula("zzz", 
/*err*/    (isac.gui.mawen.TestDATA.ast_07()));
  calc_tree_.add(new CalcFormula(pos, form));

  //-->ISA: getFormulaeFromTo 1 ([2],Res) ([3],Res) 0 false;
  //<--ISA: "6 + x / (2 * z)"
  p = new Vector<Integer>(); p.add(3);
  pos = new Position(p, "Res");
  form = new Formula("zzz", 
/*err*/    (isac.gui.mawen.TestDATA.ast_07()));
  calc_tree_.add(new CalcFormula(pos, form));

  

}
  /*
 * first example tree of <code>CalcFormula</code> for <code>TestWorksheetForMawen</code>
 */
  @SuppressWarnings("unused") // used for mocking CalcTree
private void buildTestTree() {
    // INVARIANT ON THE SEQUENCE BELOW: pos.compareTo(next_pos) = -1
		
		//-->ISA: getFormulaeFromTo 1 ([],Pbl) ([],Pbl) 0 false;
		//<--ISA: "Simplify (1 + (2 * x * (y + 3)) / (4 * z * (y + 3)) + 5)"
		Vector<Integer> p = new Vector<>();
		Position pos = new Position(p, "Pbl");
		Formula form = new Formula("Simplify (1 + (2 * x * (y + 3)) / (4 * z * (y + 3)) + 5::real)", 
/*err*/    Syntax_Phases.term_to_ast(TestsDATA.tt1()));
		calc_tree_.add(new CalcFormula(pos, form));

		// getFormulaeFromTo will need ([],Met):
		p = new Vector<Integer>();
		pos = new Position(p, "Met");
		form = new Formula("Simplify (1 + (2 * x * (y + 3)) / (4 * z * (y + 3)) + 5::real)", 
/*err*/    Syntax_Phases.term_to_ast(TestsDATA.tt1()));
		calc_tree_.add(new CalcFormula(pos, form));

		//-->ISA: getFormulaeFromTo 1 ([],Met) ([1],Frm) 0 false;
		//<--ISA: "1 + (2 * x * (y + 3)) / (4 * z * (y + 3)) + 5"
		p = new Vector<Integer>(); p.add(1);
		pos = new Position(p, "Frm");
		form = new Formula("1 + (2 * x * (y + 3)) / (4 * z * (y + 3)) + 5::real", 
/*err*/    Syntax_Phases.term_to_ast(TestsDATA.tt3()));
		calc_tree_.add(new CalcFormula(pos, form));

		//-->ISA: getFormulaeFromTo 1 ([1],Frm) ([1],Res) 0 false;
		//<--ISA: "1 + (2 * x) / (4 * z) + 5"
		p = new Vector<Integer>(); p.add(1);
		pos = new Position(p, "Res");
		form = new Formula("1 + (2 * x) / (4 * z) + 5::real", 
/*err*/    Syntax_Phases.term_to_ast(TestsDATA.tt4()));
		calc_tree_.add(new CalcFormula(pos, form));

		//-->ISA: getFormulaeFromTo 1 ([1],Res) ([2],Res) 0 false;
		//<--ISA: "1 + x / (2 * z) + 5"
		p = new Vector<Integer>(); p.add(2);
		pos = new Position(p, "Res");
		form = new Formula("1 + x / (2 * z) + 5::real", 
/*err*/    Syntax_Phases.term_to_ast(TestsDATA.tt5()));
		calc_tree_.add(new CalcFormula(pos, form));

		//-->ISA: getFormulaeFromTo 1 ([2],Res) ([3],Res) 0 false;
		//<--ISA: "6 + x / (2 * z)"
		p = new Vector<Integer>(); p.add(3);
		pos = new Position(p, "Res");
		form = new Formula("6 + x / (2 * z::real)", 
/*err*/    Syntax_Phases.term_to_ast(TestsDATA.tt6()));
		calc_tree_.add(new CalcFormula(pos, form));
  }
	
	public Formula get(Position pos) {
		int i = 0; 
		while (calc_tree_.elementAt(i).getPosition().compareTo(pos) != 0) {
			i = i + 1;
		}
		return calc_tree_.elementAt(i).getFormula();
	}
	
	public Vector<CalcFormula> getTree() {
		return calc_tree_;
	}
}
