package isac.gui.mawen;

import java.rmi.RemoteException;
import java.util.Vector;

import isac.interfaces.ICalcElement;
import isac.interfaces.ICalcIterator;
import isac.util.formulae.Assumptions;
import isac.util.formulae.CalcFormula;
import isac.util.formulae.CalcHead;
import isac.util.formulae.Context;
import isac.util.formulae.ContextMethod;
import isac.util.formulae.ContextProblem;
import isac.util.formulae.ContextTheory;
import isac.util.formulae.Formula;
import isac.util.formulae.Match;
import isac.util.formulae.MethodID;
import isac.util.formulae.Position;
import isac.util.formulae.ProblemID;
import isac.util.tactics.Tactic;
import isac.wsdialog.IContextProvider.ContextType;

public class MockDialogIterator implements ICalcIterator {
	
	Position pos_;
	private CalcFormula calc_formula_;
	private MockCalcTree calc_tree_;
	
	public MockDialogIterator(Position pos) {
		pos_ = pos;
		calc_tree_= new MockCalcTree();
	}

	@Override
	public Position getPosition() throws RemoteException {
		return pos_;
	}

	@Override
	public boolean moveRoot() throws RemoteException {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean moveCalcHead() throws RemoteException {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean moveUp() throws RemoteException {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean moveDown() throws RemoteException {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean moveLevelUp() throws RemoteException {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean moveLevelDown() throws RemoteException {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isLast() throws RemoteException {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean onCalcHead() throws RemoteException {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean onEndOfCalculation() throws RemoteException {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean switchToGuard() throws RemoteException {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean switchToModel() throws RemoteException {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public ICalcElement getElement() throws RemoteException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public Vector<CalcFormula> getFormulaeFromTo(ICalcIterator iterator_to, Integer level,
			boolean result_includes_tactics) throws RemoteException {

	  calc_tree_ = new MockCalcTree();
		Vector<CalcFormula> ct = calc_tree_.getTree();
		Vector<CalcFormula> from_to = new Vector<>();

		Position pfrom = this.getPosition();
		Position pto = iterator_to.getPosition();
		
		int i = 0; 
		if (pto.getIntList().size() != 0) {
			// iterate to start Position
			while (ct.elementAt(i).getPosition().compareTo(pfrom) != 1) {
				i = i + 1;
			}
		}
		// iterate from start Position to iterator_to
		while (ct.elementAt(i).getPosition().compareTo(pto) == -1) {
			from_to.add(ct.elementAt(i));
			i = i + 1;
		}
		from_to.add(ct.elementAt(i));
		//set for context_formula, which is needed in the context-menu
	  calc_formula_= (CalcFormula)(ct.elementAt(i));
		return from_to;
	}
	
  public CalcFormula getFormula(Position pos){
   Formula formula=calc_tree_.get(pos);
   return calc_formula_= new CalcFormula(pos, formula);  
  }
	@Override
	public CalcFormula getFormula() throws RemoteException {
	  return calc_formula_;
	}

	@Override
	public Tactic getTactic() throws RemoteException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public Vector<Tactic> getApplicableTactics(int scope) throws RemoteException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public Assumptions getAssumptions() throws RemoteException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public Assumptions getAccumulatedAssumptions() throws RemoteException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public int getLevel() throws RemoteException {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public ICalcIterator cloneIterator() throws RemoteException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public int compareToIterator(ICalcIterator compare) throws RemoteException {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public String toSMLString() throws RemoteException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public Match initMatchProblem() throws RemoteException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public Match tryMatchProblem(ProblemID problemID) throws RemoteException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public Match tryRefineProblem(ProblemID problemID) throws RemoteException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public Match initMatchMethod() throws RemoteException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public Match tryMatchMethod(MethodID methodID) throws RemoteException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public Context initContext(ContextType type) throws RemoteException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public Context checkContext(Context context2check) throws RemoteException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public Context refineProblem(Context context2refine) throws RemoteException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public CalcHead setContext(ContextProblem context2set)
			throws RemoteException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public CalcHead setContext(ContextMethod context2set)
			throws RemoteException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setContext(ContextTheory context2set) throws RemoteException {
		// TODO Auto-generated method stub
		
	}

}
