package isac.gui.mawen;

import isac.gui.mawen.termtree.TermTreeKeyAdapter;
import isac.gui.mawen.termtree.TermTreePanel;
import isac.gui.mawen.termtree.TreeNodeContent;

import java.awt.BorderLayout;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyListener;
import java.awt.event.MouseListener;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;

import junit.framework.TestCase;

/**
 * This is the test class for the tree representation of a formula, which 
 * can be accessed via context-menu of a formula. All GUI elements of the 
 * term tree must be accessible. 
 * 
 * This test is constructed under the model of <code>TestCalcheadView</code>.
 * 
 *@author NK 09052016
 **/
public class TestTermTreeView extends TestCase implements ActionListener
{
  //panel_frame_ of <code>Worksheet</code> in the real scenario
  private JFrame main_frame_;
  
  protected TermTreePanel ttp_;

  private JFrame frame_;

  private JButton button_;

  private JDialog dialog_;
  
  
  private JTree main_tree_;

  protected void setUp() throws Exception {
    main_frame_ = new JFrame("TermTreeTest");
    main_frame_.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    main_frame_.setLayout(new BorderLayout());
  }

  /*
   * Developed under the model of <code>TestCalcheadView.testShowCalchead()</code>
   */
  public void testShowTermTree() {
    //just to test the TermTree Window not the context-menu call
    dialog_ = new JDialog(frame_, "TermTreePanel WindowTest");
    button_ = new JButton("Test TermTree");
    button_.addActionListener(this);
    dialog_.add(button_);
    dialog_.setLayout(new GridBagLayout());
    main_frame_.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

   DefaultMutableTreeNode root = buildSimpleTestTree();
   //----------------------------------------------------------------------------------  
	 //DefaultMutableTreeNode root = buildLargeTermTree(); //test with calchead
	 //DefaultMutableTreeNode root= buildSimpleTermTree(); //test with Res 3
   //----------------------------------------------------------------------------------  

	  main_tree_ = new JTree(root);
	  initTermTree();
 // und hier wird die grafische Darstellung von main_tree_ (verschachtelt in Frame...) weiter gehandelt ...
    
    JPanel test_panel= new JPanel();
    test_panel.setSize(300,200);
    test_panel.add(main_tree_);
    test_panel.setVisible(true);
    dialog_.add(test_panel);
    dialog_.getContentPane().add(test_panel);
    //end JTREE
    main_frame_.getContentPane().add(button_);
    //TODO layout/manager issues because original is an internal frame not a dialog
    dialog_.setSize(600, 300);
    dialog_.pack();
    main_frame_.setSize(600, 300);
    main_frame_.setVisible(true);
    //window closes immediately without this
    try { Thread.sleep(100000); } catch (InterruptedException e) { e.printStackTrace(); }
   }

  private void initTermTree() {
    //expand all nodes
	   for (int i = 0; i < main_tree_.getRowCount(); i++) {
       main_tree_.expandRow(i);
     }
	  //remove default behavior
	  for(MouseListener ml : main_tree_.getMouseListeners()){
	    main_tree_.removeMouseListener(ml);
	  }
	  for(KeyListener kl : main_tree_.getKeyListeners()){
	      main_tree_.removeKeyListener(kl);
	  }
	  main_tree_.addKeyListener(new TermTreeKeyAdapter(main_tree_));
  }
  
  private DefaultMutableTreeNode buildSimpleTestTree() {
    DefaultMutableTreeNode root = new DefaultMutableTreeNode(new TreeNodeContent("+", "6 + x / ( 2 * z )"));
    root.add(new DefaultMutableTreeNode("6"));
    DefaultMutableTreeNode operator1 = new DefaultMutableTreeNode(new TreeNodeContent("/", "x / (2 * z)"));
    root.add(operator1);
    operator1.add(new DefaultMutableTreeNode("x"));
    DefaultMutableTreeNode operator2 = new DefaultMutableTreeNode(new TreeNodeContent("*", "2 * z"));
    operator1.add(operator2);
    operator2.add(new DefaultMutableTreeNode("2"));
    operator2.add(new DefaultMutableTreeNode("z"));
   return root;
  }
  
  @Override
  public void actionPerformed(ActionEvent e) {
    // TODO Auto-generated method stub
    if (e.getSource() == button_) {
      dialog_.setVisible(true);
    }
  }
}
