package isac.gui.mawen.editor

import isac.gui.mawen.syntax.Ast._

object TestDATA {
  // xi = 0x03BE.toChar.toString()
  def s1 = Variable ("a")
  
  def s2 = Constant("Groups.plus_class.plus")
  
  def a1 = Appl(List(Constant("Groups.plus_class.plus"), Variable ("y"), Variable ("b")))
    
  def a2 = Appl(List(Constant("Groups.plus_class.plus"), Variable ("a"), Appl(List(Constant("Groups.plus_class.plus"), Variable ("b"), Variable ("c")))))
  
  def a3 = Appl(List(Constant("Groups.plus_class.plus"), Variable ("a"), Appl(List(Constant("Groups.plus_class.plus"), Variable ("i"), Appl(List(Constant("Groups.plus_class.plus"), Variable ("y"), Variable ("X")))))))
  
  // a^b
  def e1 = Appl(List(Constant("^"), Variable ("a"), Variable ("b")))
  // a^b^c
  def e2 = Appl(List(Constant("^"), Variable ("a"), Appl(List(Constant("^"), Variable ("b"), Variable ("c")))))
  // a^b^c^d^e
  def e3 = Appl(List(Constant("^"), Variable ("a"), Appl(List(Constant("^"), Variable ("b"), Appl(List(Constant("^"), Variable ("c"), Appl(List(Constant("^"), Variable ("d"), Variable ("e")))))))))
  // a^(b+c)
  def e4 = Appl(List(Constant("^"), Variable("a"), Appl(List(Constant("Groups.plus_class.plus"), Variable("b"), Variable("c")))))
  // (a+b)^(b+c)
  def e5 = Appl(List(Constant("^"), Appl(List(Constant("Groups.plus_class.plus"), Variable("a"), Variable("b"))), Appl(List(Constant("Groups.plus_class.plus"), Variable("c"), Variable("d")))))
  
  def f1 = Appl(List(Constant("Fields.inverse_class.divide"), Variable("a"), Variable("b")))
  
  def f2 = Appl(List(Constant("/"), Variable("a"), Appl(List(Constant("Groups.plus_class.plus"), Variable("b"), Variable("c")))))
      
  def f3 = Appl(List(Constant("/"), Appl(List(Constant("Groups.plus_class.plus"), Variable("b"), Variable("c"))),Variable("a")))
  
  // a + b/c
  def f4 = Appl(List(Constant("Groups.plus_class.plus"), Variable("a"), Appl(List(Constant("/"),Variable("b"), Variable("c")))))
  //a^b/c
  def f5 = Appl(List(Constant("/"), Appl(List(Constant("^"), Variable("a"), Variable("b"))), Variable("c")))
  
  
  
  
  /*
   * Examples for reference from UC "User guidance by marked subterms and fill-in-gaps".
   * Asts copied from ScalaAstFromString#test_create_Editor_UC
   * and adorned with BOXes, GAPs and CURSOR position.
   * The meaning of numbers "n" in "BOX.n" is as follows
   *   .1  : an arbitrary colour
   *   .2  : an arbitrary colour
   *   .1a : a colour similar to .1
   *   .2a : a colour similar to .2
   * Experience with coding will show, if Constant("BOX") better would have 2 arguments:
   *   the first argument  Constant("BOX")
   *   the second argument Constant("1a")
   *   This would simplify pattern matching
   */
  def box_05 =
    Appl(List(
      Constant("Groups.plus_class.plus"),
      Appl(List(
        Constant("Diff.d_d"),
        Variable("x"),
        Variable("x"))),
      Appl(List(
        Constant("Diff.d_d"),
        Variable("x"),
        Appl(List(               //added to test_create_..
          Constant("BOX.1"),     //.1 fixes the colour within this group of formulas
          Appl(List(
            Constant("Transcendental.sin"),
            Appl(List(           //added to test_create_..
              Constant("BOX.2"), //.2 fixes the colour within this group of formulas
              Appl(List(
                Constant("Power.power_class.power"),
                Variable("x"),
                Variable("2")))))))))))))

  def box_06 =
    Appl(List(
      Constant("HOL.eq"),
      Appl(List(
        Constant("Diff.d_d"),
        Variable("bdv"),
        Appl(List(               //added to test_create_..
          Constant("BOX.1"),     //.1 fixes the colour within this group of formulas
          Appl(List(
            Constant("Transcendental.sin"),
            Appl(List(           //added to test_create_..
              Constant("BOX.2"), //.2 fixes the colour within this group of formulas
              Variable("u"))))))))),
      Appl(List(
        Constant("Groups.times_class.times"),
        Appl(List(               //added to test_create_..
          Constant("BOX.1a"),    //.1a fixes the colour within this group of formulas
          Appl(List(
            Constant("Transcendental.cos"),
            Variable("u"))))),
        Appl(List(
          Constant("Diff.d_d"),
          Variable("bdv"),
          Appl(List(             //added to test_create_..
            Constant("BOX.2a"),  //.2a fixes the colour within this group of formulas
            Variable("u")))))))))

  //here the CURSOR coincides with a GAP and a BOX
  def box_07_with_cursor =
    Appl(List(
      Constant("Groups.plus_class.plus"),
      Appl(List(Constant("Diff.d_d"),
        Variable("x"),
        Variable("x"))),
      Appl(List(
        Constant("Groups.times_class.times"),
        Appl(List(               //added to test_create_..
          Constant("BOX.1a"),    //.1a fixes the colour within this group of formulas
          Appl(List(
            Constant("Transcendental.cos"),
            Appl(List(
              Constant("Power.power_class.power"),
              Variable("x"),
              Variable("2"))))))),
        Appl(List(
          Constant("Diff.d_d"),
          Variable("x"),
          Appl(List(             //added to test_create_..
            Constant("BOX.2a"),  //.2a fixes the colour within this group of formulas
            Appl(List(
              Constant("CURSOR"),
              Variable("GAP")))))))))))

  //------- some more examples related to BOX, GAP and CURSOR ------
  //here the BOX, the GAP and the CURSOR are separated
  def box_gap_cursor =
    Appl(List(
      Constant("Groups.plus_class.plus"),
        Appl(List( 
          Constant("BOX.1"),    //a BOX containing "a"
          Variable("a"))),
      Appl(List(
        Constant("Groups.plus_class.plus"),
        Appl(List(
          Constant("GAP"))),    //a GAP as a Constant with 0 arguments
        Appl(List(
          Constant("CURSOR"),   //the coursor at "c" (at the beginning of the sub-term)
          Variable("c")))))))
    
  //here a BOX with the CURSOR on a GAP as in box_07_with_cursor above
  def box_with_cursor_on_gap =
        Appl(List( 
          Constant("BOX.1"),
          Appl(List(
            Constant("CURSOR"),
            Variable("GAP")))))
            
  /*
   * GAPs supporting input of formulas.
   * See UC "Input of specific operators is supported by fill-in-gaps."
   */
  //1(a) input "a + b": input "+" (while starting "a + " should be possible as well)
  def in_1a = 
    Appl(List(
      Constant("Groups.plus_class.plus"),
      Variable("GAP"),
      Variable("GAP")))
    
  //1(b) input "b / c" instead of "b" above: start with "/"
  def in_1b = 
    Appl(List(
      Constant("Groups.plus_class.plus"),
      Variable("a"),
      Appl(List(
        Constant("Fields.inverse_class.divide"),
        Variable("GAP"),
        Variable("GAP")))))

  //1(c) input "b / c" instead of "b" above: start with "/"
  def in_1c = 
    Appl(List(
      Constant("Groups.plus_class.plus"),
      Variable("a"),
      Appl(List(
        Constant("Fields.inverse_class.divide"),
        Variable("b"),
        Variable("GAP")))))

}