package isac.gui.mawen.editor

import isac.gui.mawen.syntax.Ast._

object TestDATAeditor {
  // xi = 0x03BE.toChar.toString()
  def s1 = Variable ("a")
  
  def s2 = Constant("+")
  
  def a1 = Appl(List(Constant("+"), Variable ("y"), Variable ("b")))
    
  def a2 = Appl(List(Constant("+"), Variable ("a"), Appl(List(Constant("+"), Variable ("b"), Variable ("c")))))
  
  def a3 = Appl(List(Constant("+"), Variable ("a"), Appl(List(Constant("+"), Variable ("i"), Appl(List(Constant("+"), Variable ("y"), Variable ("X")))))))
  
  // a^b
  def e1 = Appl(List(Constant("^"), Variable ("a"), Variable ("b")))
  // a^b^c
  def e2 = Appl(List(Constant("^"), Variable ("a"), Appl(List(Constant("^"), Variable ("b"), Variable ("c")))))
  // a^b^c^d^e
  def e3 = Appl(List(Constant("^"), Variable ("a"), Appl(List(Constant("^"), Variable ("b"), Appl(List(Constant("^"), Variable ("c"), Appl(List(Constant("^"), Variable ("d"), Variable ("e")))))))))
  // a^(b+c)
  def e4 = Appl(List(Constant("^"), Variable("a"), Appl(List(Constant("+"), Variable("b"), Variable("c")))))
  // (a+b)^(b+c)
  def e5 = Appl(List(Constant("^"), Appl(List(Constant("+"), Variable("a"), Variable("b"))), Appl(List(Constant("+"), Variable("c"), Variable("d")))))
  
  def f1 = Appl(List(Constant("/"), Variable("a"), Variable("b")))
  
  def f2 = Appl(List(Constant("/"), Variable("a"), Appl(List(Constant("+"), Variable("b"), Variable("c")))))
      
  def f3 = Appl(List(Constant("/"), Appl(List(Constant("+"), Variable("b"), Variable("c"))),Variable("a")))
  
  // a + b/c
  def f4 = Appl(List(Constant("+"), Variable("a"), Appl(List(Constant("/"),Variable("b"), Variable("c")))))
  //a^b/c
  def f5 = Appl(List(Constant("/"), Appl(List(Constant("^"), Variable("a"), Variable("b"))), Variable("c")))
  
  // a + (b/(c/d))
  def f6 = 
    Appl(List(
      Constant("Groups.plus_class.plus"),
      Variable("a"),
      Appl(List(
        Constant("Fields.inverse_class.divide"),
        Constant("a"),
        Appl(List(
            Constant("Fields.inverse_class.divide"),
            Variable("a"),
            Variable("a")
        ))
      ))
    ))
    
    
  // a + (a / ( a + ( a / a)))
  def f7 = 
    Appl(List(
      Constant("Groups.plus_class.plus"),
      Variable("a"),
      Appl(List(
        Constant("Fields.inverse_class.divide"),
        Constant("a"),
        Appl(List(
          Constant("Groups.plus_class.plus"),
          Variable("a"),
          Appl(List(
              Constant("Fields.inverse_class.divide"),
              Variable("a"),
              Variable("a")
          ))
        ))
      ))
    ))
  
  def f8  = Appl(List(Constant("GAP"), Constant("CURSOR")))
        
  def f9 = Appl(List(Constant("Simplify.Simplify"), Appl(List(Constant("Groups.plus_class.plus"), Appl(List(Constant("Groups.plus_class.plus"), Variable("1"), Appl(List(Constant("Fields.inverse_class.divide"), Variable("1"), Variable("2"))))), Appl(List(Constant("Fields.inverse_class.divide"), Appl(List(Constant("Groups.plus_class.plus"), Appl(List(Constant("Fields.inverse_class.divide"), Variable("2"), Appl(List(Constant("Groups.plus_class.plus"), Variable("x"), Variable("3"))))), Appl(List(Constant("Fields.inverse_class.divide"), Variable("2"), Appl(List(Constant("Groups.minus_class.minus"), Variable("x"), Variable("3"))))))), Appl(List(Constant("Fields.inverse_class.divide"), Appl(List(Constant("Groups.times_class.times"), Variable("8"), Variable("x"))), Appl(List(Constant("Groups.minus_class.minus"), Appl(List(Constant("Power.power_class.power"), Variable("x"), Variable("2"))), Variable("9")))))))))))
  
  /*
   * Examples for reference from UC "User guidance by marked subterms and fill-in-gaps".
   * Asts copied from ScalaAstFromString#test_create_Editor_UC
   * and adorned with BOXes, GAPs and CURSOR position.
   */
  def box_05 =
    Appl(List(
      Constant("Groups.plus_class.plus"),
      Appl(List(
        Constant("Diff.d_d"),
        Variable("x"),
        Variable("x"))),
      Appl(List(
        Constant("Diff.d_d"),
        Variable("x"),
        Appl(List(               // added to test_create_..
          Constant("BOX.1"),     // added, fixes the colour within this group of formulas
          Appl(List(
            Constant("Transcendental.sin"),
            Appl(List(           //added to test_create_..
              Constant("BOX.2"), // added, fixes the colour within this group of formulas
              Appl(List(
                Constant("Power.power_class.power"),
                Variable("x"),
                Variable("2")))))))))))))

  def box_06 =
    Appl(List(
      Constant("HOL.eq"),
      Appl(List(
        Constant("Diff.d_d"),
        Variable("bdv"),
        Appl(List(               //added to test_create_..
          Constant("BOX.1"),     //added, fixes the colour within this group of formulas
          Appl(List(
            Constant("Transcendental.sin"),
            Appl(List(           //added to test_create_..
              Constant("BOX.2"), //added, fixes another colour within this group of formulas
             Variable("u"))))))))),
      Appl(List(
        Constant("Groups.times_class.times"),
        Appl(List(               //added to test_create_..
          Constant("BOX.11"),    //added, fixes the colour within this group of formulas
          Appl(List(
            Constant("Transcendental.cos"),
            Variable("u"))))),
        Appl(List(
          Constant("Diff.d_d"),
          Variable("bdv"),
          Appl(List(             //added to test_create_..
            Constant("BOX.12"),  //added, fixes another colour within this group of formulas
            Variable("u")))))))))

  //here the CURSOR coincides with a GAP and a BOX
  def box_07_with_cursor =
    Appl(List(
      Constant("Groups.plus_class.plus"),
      Appl(List(Constant("Diff.d_d"),
        Variable("x"),
        Variable("x"))),
      Appl(List(
        Constant("Groups.times_class.times"),
        Appl(List(               //added to test_create_..
          Constant("BOX.11"),    //added, fixes the colour within this group of formulas
          Appl(List(
            Constant("Transcendental.cos"),
            Appl(List(
              Constant("Power.power_class.power"),
              Variable("x"),
              Variable("2"))))))),
        Appl(List(
          Constant("Diff.d_d"),
          Variable("x"),
          Appl(List(             //added to test_create_..
            Constant("BOX.12"),  //added, fixes another colour within this group of formulas
            Appl(List(
              Constant("CURSOR"),
              Constant("GAP")))))))))))

  /*------- CURSOR can be in front of an ast or after an ast;
   * the latter happens during input beginning with empty formula.
   * Example formula "a + (b + c)/(d + e)
   */
  def cursor_before_fraction = 
    Appl(List(
      Constant("Groups.plus_class.plus"),
      Variable("a"),
      Appl(List(                                 //++
        Constant("CURSOR"),                      //++
        Appl(List(
          Constant("Fields.inverse_class.divide"),
          Appl(List(
            Constant("Groups.plus_class.plus"),
            Variable("b"),
            Variable("c"))),
          Appl(List(
            Constant("Groups.plus_class.plus"),
            Variable("d"),
            Variable("e")))
          ))                                     //++
      ))))
  def cursor_before_numerator = 
    Appl(List(
      Constant("Groups.plus_class.plus"),
      Variable("a"),
      Appl(List(
        Constant("Fields.inverse_class.divide"),
        Appl(List(                                 //++
          Constant("CURSOR"),                      //++
          Appl(List(
            Constant("Groups.plus_class.plus"),
            Variable("b"),
            Variable("c")))
          )),                                      //++
        Appl(List(
          Constant("Groups.plus_class.plus"),
          Variable("d"),
          Variable("e")))
      ))))
  // here the denominator could be extended
  def cursor_after_denominator = 
    Appl(List(
      Constant("Groups.plus_class.plus"),
      Variable("a"),
      Appl(List(
        Constant("Fields.inverse_class.divide"),
        Appl(List(
          Constant("Groups.plus_class.plus"),
          Variable("b"),
          Variable("c"))),
        Appl(List(                                 //++
          Appl(List(
            Constant("Groups.plus_class.plus"),
            Variable("d"),
            Variable("e"))),
          Constant("CURSOR")                       //++
          ))                                       //++
      ))))
  // transition from cursor_after_denominator to here is usual input procedere
  def cursor_after_fraction = 
    Appl(List(
      Constant("Groups.plus_class.plus"),
      Variable("a"),
      Appl(List(                                   //++
        Appl(List(
          Constant("Fields.inverse_class.divide"),
          Appl(List(
            Constant("Groups.plus_class.plus"),
            Variable("b"),
            Variable("c"))),
          Appl(List(
            Constant("Groups.plus_class.plus"),
            Variable("d"),
            Variable("e"))),
        Constant("CURSOR")                         //++
          ))                                       //++
      ))))

  //------- some more examples related to BOX, GAP and CURSOR ------
  //here the BOX, the GAP and the CURSOR are separated
  def box_gap_cursor =
    Appl(List(
      Constant("Groups.plus_class.plus"),
        Appl(List( 
          Constant("BOX.1"),      //a BOX containing "a", 1 fixes the colour within this group of formulas
          Variable("a"))),
      Appl(List(
        Constant("Groups.plus_class.plus"),
        Constant("GAP"),        //a GAP as an ast
        Appl(List(
          Constant("CURSOR"),   //the coursor at "c" (at the beginning of the sub-term)
          Variable("c")))))))
    
  //here a BOX with the CURSOR on a GAP as in box_07_with_cursor above
  def box_with_cursor_on_gap =
        Appl(List( 
          Constant("BOX.1"),       // added, fixes the colour within this group of formulas
          Appl(List(
            Constant("CURSOR"),
            Constant("GAP")))))
            
  /*
   * GAPs supporting input of formulas.
   * See UC "Input of specific operators is supported by fill-in-gaps."
   */
  //1(a) input "a + b": input "+" (while starting "a + " should be possible as well)
  def in_1a = 
    Appl(List(
      Constant("Groups.plus_class.plus"),
      Constant("GAP"),
      Constant("GAP")))
    
  //1(b) input "b / c" instead of "b" above: start with "/"
  def in_1b = 
    Appl(List(
      Constant("Groups.plus_class.plus"),
      Variable("a"),
      Appl(List(
        Constant("Fields.inverse_class.divide"),
        Constant("GAP"),
        Constant("GAP")))))

  //1(c) input "b / c" instead of "b" above: start with "/"
  def in_1c = 
    Appl(List(
      Constant("Groups.plus_class.plus"),
      Variable("a"),
      Appl(List(
        Constant("Fields.inverse_class.divide"),
        Variable("b"),
        Constant("GAP")))))

  /* ---------------------------------------------------------------------------------
   * nested representation of BOX, CURSOR, GAP
   * # BOX, denoted by [ast], where ast is some (sub-)term, 
   *   un-boxed  <-->  BOXed
   *   ast       <-->  Appl(List(Constant("BOX"), Constant("1"), ast))
   *   
   *   Scala pattern matching may include in if:
   *   with Appl(Constant("BOX.1") :: ast).
   *   "1" denotes a colour, "11" a colour similar to "1" (there are at most 2 "similar" colours)
   *   TODO: introduce notion of "similar" colours
   *   numbers "1".."9" are mapped in <code>editor.Settings.CollorMapping</code>
   *   
   * # CURSOR, denoted by {ast}, ast is some (sub-)term preceded by the cursor
   *   without   <-->  with CURSOR
   *   ast       <-->  Appl(List(Constant("CURSOR"), ast))    cursor in front of ast
   *   ast       <-->  Appl(List(ast, Constant("CURSOR")))    cursor after the ast
   *   
   *   The cursor might have a certain size according to the size of ast.
   *   
   * # GAP, denoted by #
   *   without   <-->  replaced by GAP
   *   ast       <-->  Constant("GAP")
   *   
   * Note: CURSOR, GAP as Constant() allows free use of Variable("CURSOR") etc.
   */
   def nest_BOX_1 = //"[aaa] + bbb", "[]" denotes a box
    Appl(List(
      Constant("Groups.plus_class.plus"),
      Appl(List(
        Constant("BOX.1"),
        Variable("aaa"))),
      Variable("bbb")))
  def nest_BOX_2 = //"aaa + [bbb]"
    Appl(List(
      Constant("Groups.plus_class.plus"),
      Variable("aaa"),
      Appl(List(
        Constant("BOX.1"),
        Variable("bbb")))))
  def nest_BOX_3 = //"[aaa + bbb]"
    Appl(List(
      Constant("BOX.1"),
        Appl(List(
          Constant("Groups.plus_class.plus"),
          Variable("aaa"),
          Variable("bbb")))))
   def nest_BOX_1_CURSOR = //"[{aaa}] + bbb"  the cursor stands at the beginning of "aaa"
    Appl(List(
      Constant("Groups.plus_class.plus"),
      Appl(List(
        Constant("BOX.1"),
        Appl(List(
          Constant("CURSOR"),
          Variable("aaa"))))),
      Variable("bbb")))
   def nest_BOX_1_CURSOR_GAP = //"[{#}] + bbb"
    Appl(List(
      Constant("Groups.plus_class.plus"),
      Appl(List(
        Constant("BOX.1"),
        Appl(List(
          Constant("CURSOR"),
          Constant("GAP"))))),
      Variable("bbb")))
   def nest_BOX_1_CURSOR_b = //"[aaa] + {bbb}"
    Appl(List(
      Constant("Groups.plus_class.plus"),
      Appl(List(
        Constant("BOX.1"),
        Variable("aaa"))),
      Appl(List(
        Constant("CURSOR"),
        Variable("bbb")))))
   /*
    *  One and the same code can handle two different behaviours 
    *  (according to respective structure of Ast):
    *  (1) The cursor stands WITHIN the box, in front of the boxes content.
    *      This invites to edit the content of the box ???
    *  (2) The cursor stands OUTSIDE, in front of the box.
    *      This invites to edit the whole box ???
    */
  def nest_CURSOR_BOX_3A = //"[{aaa + bbb}]" case (1)
    Appl(List(
      Constant("BOX.1"),
      Appl(List(
        Constant("CURSOR"),
        Appl(List(
          Constant("Groups.plus_class.plus"),
          Variable("aaa"),
          Variable("bbb")))))))
   def nest_CURSOR_BOX_3B = //"{[aaa + bbb]}" case (2)
    Appl(List(
      Constant("CURSOR"),
      Appl(List(
        Constant("BOX.8"),
          Appl(List(
            Constant("Groups.plus_class.plus"),
            Variable("aaa"),
            Variable("bbb")))))))
   
   /* 
    * Input of "a + b/c + d" from scratch, UC \label{UC:gaps} Pt.2.
    * The formula's structure requires 10 key hits for input of above 7 characters.
    * Note the challenge of associativity in step UC_input_8b.
    */
   def UC_input_0 =
    Appl(List(
      Constant("CURSOR"),
      Constant("GAP")))
   def UC_input_1 =       // input "a"
    Appl(List(
      Variable("a"),
      Constant("CURSOR")
      ))
   def UC_input_2 =       // input "+"
    Appl(List(
      Constant("Groups.plus_class.plus"),
      Variable("a"),
      Appl(List(
        Constant("CURSOR"),
        Constant("GAP")))
      ))
   def UC_input_3 =       // input "/" (instead of clicking menu item)
    Appl(List(
      Constant("Groups.plus_class.plus"),
      Variable("a"),
      Appl(List(
        Constant("Fields.inverse_class.divide"),
        Appl(List(
          Constant("CURSOR"),
          Constant("GAP"))),
        Constant("GAP")
      ))))
   def UC_input_4 =       // input "b"
    Appl(List(
      Constant("Groups.plus_class.plus"),
      Variable("a"),
      Appl(List(
        Constant("Fields.inverse_class.divide"),
        Appl(List(
          Variable("b"),
          Constant("CURSOR"))),
        Constant("GAP")
      ))))
   def UC_input_5 =       // input <next subterm on same level>
    Appl(List(
      Constant("Groups.plus_class.plus"),
      Variable("a"),
      Appl(List(
        Constant("Fields.inverse_class.divide"),
        Variable("b"),
        Appl(List(
          Constant("CURSOR"),
          Constant("GAP")))
      ))))
   def UC_input_6 =       // input "c"
    Appl(List(
      Constant("Groups.plus_class.plus"),
      Variable("a"),
      Appl(List(
        Constant("Fields.inverse_class.divide"),
        Variable("b"),
        Appl(List(
          Variable("c"),
          Constant("CURSOR")))
      ))))
   def UC_input_7 =       // input <one level up>
    Appl(List(
      Constant("Groups.plus_class.plus"),
      Variable("a"),
      Appl(List(
        Appl(List(
          Constant("Fields.inverse_class.divide"),
          Variable("b"),
          Variable("c"))),
        Constant("CURSOR")
      ))))
// this would create parentheses "a + (b/c + d)":
//   def UC_input_8a =       // input "+"
//    Appl(List(
//      Constant("Groups.plus_class.plus"),
//      Variable("a"),
//      Appl(List(
//        Constant("Groups.plus_class.plus"), // this would create parentheses !
//        Appl(List(
//          Appl(List(
//            Constant("Fields.inverse_class.divide"),
//            Variable("b"),
//            Variable("c"))))),
//          Appl(List(
//            Constant("CURSOR"),
//            Constant("GAP")))
//      ))))
   def UC_input_8b =      // input "+"
    Appl(List(
      Constant("Groups.plus_class.plus"),
      Appl(List(
        Constant("Groups.plus_class.plus"),
        Variable("a"),
          Appl(List(
            Constant("Fields.inverse_class.divide"),
            Variable("b"),
            Variable("c"))),
        Appl(List(
          Constant("CURSOR"),
          Constant("GAP")))
      ))))
   def UC_input_9 =       // input "d"
    Appl(List(
      Constant("Groups.plus_class.plus"),
      Appl(List(
        Constant("Groups.plus_class.plus"),
        Variable("a"),
          Appl(List(
            Constant("Fields.inverse_class.divide"),
            Variable("b"),
            Variable("c"))),
        Appl(List(
          Variable("d"),
          Constant("CURSOR")))
      ))))
   def UC_input_10 =      // input some key exiting editor
    Appl(List(
      Constant("Groups.plus_class.plus"),
      Appl(List(
        Constant("Groups.plus_class.plus"),
        Variable("a"),
          Appl(List(
            Constant("Fields.inverse_class.divide"),
            Variable("b"),
            Variable("c"))))),
      Variable("d")
      ))
  
}