/**
 * @author Walther Neuper
 * Created on Mar 30, 2017
 * (c) due to copyright terms
 */

package isac.gui.mawen.syntax

import isac.bridge.Isabelle_Isac
import isac.bridge.xml.DataTypes
import isac.gui.mawen.syntax.Ast._   //"._" simplifies "Ast.Ast" to "Ast"
import info.hupel.isabelle.japi._    // for JSystem

import junit.framework.TestCase
import org.junit.Assert._

/** 
 * Create libisabelle's Scala Ast from String for tests.
 * Compare ScalaTermFromString.
 */
class ScalaAstFromString extends TestCase {
  
  var sys_ : JSystem = null
  override def setUp() {
    sys_ = Isabelle_Isac.connect();
  }
  
  def test_etc() {
    println("/--BEGIN isac.gui.mawen.syntax.ScalaAstFromString#test_etc");
    
    //numeral 123 is Ast.Variable("123")
    var term_str = "123"
    var tree = sys_.invoke(isac.bridge.IsacOperations.SCALATERM_OF_STRING, term_str)
    var form = DataTypes.xml_to_Formula_NEW(tree)
    var ast = form.getTerm
    //println(Ast.raw_string_of(ast))
//    assertEquals(ast, Ast.Variable("123"))
    assertEquals(term_str, Ast.math_string_of(ast))

    //create <code>TestDATA.box_07_with_cursor</code>
    term_str = "[aaa, bbb, ccc]"
    tree = sys_.invoke(isac.bridge.IsacOperations.SCALATERM_OF_STRING, term_str)
    form = DataTypes.xml_to_Formula_NEW(tree)
    ast = form.getTerm
    assertEquals(term_str, Ast.math_string_of(ast))
    
    println("\\--END isac.gui.mawen.syntax.ScalaAstFromString#test_etc");
  }

  override def tearDown() {
    sys_.dispose()
    super.tearDown()
  }
}