/*
 * @author Walther Neuper, member of the ISAC-team, 
 * Copyright (c) 2005 by Walther Neuper 
 * created Apr 13, 2005 3:45:36 PM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to PGPL license terms.
 */
package isac.session;

import java.rmi.RemoteException;
import junit.framework.TestCase;

import isac.users.IUserManager;
import isac.users.User;
import isac.users.UserManager;

/**
 * @author neuper
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class TestUserManager extends TestCase {

	protected void setUp() throws Exception {
		super.setUp();
	}

	/**
	 * trace the login down to the UserManager
	 * 
	 * @exception RemoteException
	 *                if XSessionManager=ObjectManager NOT launched
	 *                (ObjectManager launchedd after KEStore, BridgeMain)
	 * @see isac.util.user.TestUser#testGetUserSettings
	 */
	public void testLogin() {
		System.out.println("---BEGIN isac.session.TestUserManager#testLogin");

		String name = "//localhost/isac-ObjectManager";
		
		try {
			IUserManager user_manager = UserManager.getInstance();
		
			user_manager.login("x", "x", null);
			User user = user_manager.getUser("0");

			String usern = user.getUsername();
			assertEquals("username", usern, "x");

		} catch (RemoteException exc) {
			System.err.println("no rmiregistry runing on server " + name
					+ " no connection possible --- try later");
		}
		System.out.println("---END isac.session.TestUserManager#testLogin");
	}
}