package isac.users;

import junit.framework.Assert;
import junit.framework.TestCase;
import org.junit.Before;
import org.junit.Test;

/**
 *
 * @author tzilling@sbox.tugraz.at
 */
public class TestUser extends TestCase {

    User userNoDomain;
    User userWithDomainForwardSlash;
    User userWithDomainBackSlash;

    public TestUser() {
    }

    @Before
    @Override
    protected void setUp() throws Exception {
        super.setUp();
        userNoDomain = new User("test", null);
        userWithDomainForwardSlash = new User("myDomain/test1", null);
        userWithDomainBackSlash = new User("myDomain2\\test2", null);
    }

    @Test
    public void testGetUserAdmin() {
    }

    @Test
    public void testGetUserModel() {
    }

    @Test
    public void testGetUserSettings() {
    }

    @Test
    public void testGetUsername() {
        Assert.assertEquals("test", userNoDomain.getUsername());

        Assert.assertEquals("myDomain/test1", userWithDomainForwardSlash.getUsername());

        Assert.assertEquals("myDomain2\\test2", userWithDomainBackSlash.getUsername());
    }

    @Test
    public void testGetDomain() {
        Assert.assertEquals("Should have no domain", "", userNoDomain.getDomain());

        Assert.assertEquals("Test with '/', should find 'myDomain' domain", "myDomain", userWithDomainForwardSlash.getDomain());

        Assert.assertEquals("Test with '\\', should find 'myDomain2' domain", "myDomain2", userWithDomainBackSlash.getDomain());
    }

    @Test
    public void testHasDomain() {
        Assert.assertEquals("Should have no domain", false, userNoDomain.hasDomain());

        Assert.assertEquals("Test with '/', should find 'myDomain' domain", true, userWithDomainForwardSlash.hasDomain());

        Assert.assertEquals("Test with '\\', should find 'myDomain2' domain", true, userWithDomainBackSlash.hasDomain());
    }

    @Test
    public void testGetUsernameWithoutDomain() {
        Assert.assertEquals("Should have no domain", "test", userNoDomain.getUsernameWithoutDomain());

        Assert.assertEquals("Test with '/', should find 'test1'", "test1", userWithDomainForwardSlash.getUsernameWithoutDomain());

        Assert.assertEquals("Test with '\\', should find 'test2'", "test2", userWithDomainBackSlash.getUsernameWithoutDomain());
    }

    @Test
    public void testGetUserpath() {
    }

    @Test
    public void testGetLanguage() {
    }
}
