package isac.users;

import isac.TestConstants;
import isac.browserdialog.IBrowserDialog;
import isac.util.ObjectManagerPaths;

import java.rmi.RemoteException;

import junit.framework.TestCase;

/**
 * If this test should work properly, KEStore and ObjectManager have to be started.
 * 
 * Note WN170215: Since introduction of PIDE/libisabelle TestKEStoreCommunication
 * destroys several other TestCases:
 * test* 2,4,6,.. in @see isac.users.TestKEStoreCommunication,
 * all test* in @see isac.wsdialog.TestSolve,
 * all test* in @see isac.wsdialog.TestSolveEtc.
 * Thus @see isac.users.TestUserManager is outcommented in @see isac.users.Testall,
 * !!! but it worked 20170215 !!!
 * 
 */
public class TestUserManager extends TestCase {
  
  
  private IUserManager userManager;
  
  @Override
  protected void setUp() throws Exception {
    super.setUp();
    ObjectManagerPaths.SESSION_MANAGER_USER_PATH = "/isac/xmldata/users/";
    ObjectManagerPaths.KESTORE_PATH = TestConstants.KESTORE.KEYSTORE_SERVER_URL;
    userManager = UserManager.getInstance();
  }

  @Override
  protected void tearDown() throws Exception {
    userManager = null;
    super.tearDown();
  }

  public void testLogin() {
    try {
      IBrowserDialog browserDialog = userManager.login("x", "x", null);
      assertTrue(true);
      System.out.print(browserDialog); //suppresses warning "usused"
    }
    catch (RemoteException e) {
      e.printStackTrace();
      assertTrue(false);
    }
    
    
  }

}
