/*
 * @author Walther Neuper, member of the ISAC-team, 
 * Copyright (c) 2005 by Walther Neuper
 * created Jun 26, 2005 2:05:56 PM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to PGPL license terms.
 */
package isac.util.tactics;

import isac.util.formulae.Formula;

import java.util.Vector;

import junit.framework.TestCase;

/**
 * @author neuper
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class TestTactic extends TestCase {

    /**
     * generate some Tactic's
     */
    public void testTactics() throws Exception {
        System.out.println("---BEGIN isac.util.tactics.TestTactic#testTactics");

		Vector<String> keylist = new Vector<>();
        keylist.add("normalize");
        keylist.add("polynomial");
        keylist.add("univariate");
        keylist.add("equation");
        Tactic tac = new StringListTactic("Specify_Problem", keylist);
        System.out.println(tac.toSMLString());
        assertEquals("Specify_Problem [\"normalize\",\"polynomial\","
                + "\"univariate\",\"equation\"]", tac.toSMLString());

        System.out.println("---END isac.util.tactics.TestTactic#testTactics");
    }

    /**
     * test method showToBeginner
     */
    public void testShowToBeginner() throws Exception {
        System.out
                .println("---BEGIN isac.util.tactics.TestTactic#testShowToBeginner");

        Tactic tac = new Rewrite();
        Theorem thm = new Theorem();
        Formula form = new Formula();
        form.setText("[| ?l is_const; ?m is_const |] ==> "
                + "?l * ?n + ?m * ?n = (?l + ?m) * ?n");
        thm.setFormula(form);
        ((Rewrite) tac).setTheorem(thm);
        
        assertEquals("l * n + m * n = (l + m) * n", tac.showToBeginner());

        form.setText("?a = ?a");
        thm.setFormula(form);
        ((Rewrite) tac).setTheorem(thm);
        assertEquals("a = a", tac.showToBeginner());

        tac = null;
        tac = new RewriteInst();
        form.setText("(?k + ?bdv = ?m) = (?bdv = ?m + -1 * ?k)");
        thm.setFormula(form);
        ((RewriteInst) tac).setTheorem(thm);
        assertEquals("(k + bdv = m) = (bdv = m + -1 * k)", tac.showToBeginner());
        
        System.out
                .println("---END isac.util.tactics.TestTactic#testShowToBeginner");
    }
}