package isac.wsdialog;

import isac.browserdialog.BrowserDialog;
import isac.session.Session;
import isac.util.Formalization;
import isac.session.DialogGuide;
import isac.util.parser.FormalizationDigest;
import isac.wsdialog.IContextProvider.ContextType;

import java.rmi.RemoteException;
import java.util.Vector;

/**
 * Mocks the WorksheetRMI for TestInitDialog*
 *
 * @author Markus Kienleitner MKI
 */
public class MockExampleDialog extends BrowserDialog {

  /**
   * For serialization, see corresponding API Documentation; value generated
   * by eclipse to avoid a warning
   */
  private static final long serialVersionUID = 338252357001819521L;

  public MockExampleDialog(Session session, DialogGuide dialog) throws RemoteException {
    super(session, dialog);
    context_type_ = ContextType.CONTEXT_EXAMPLES;
    hierarchy_ = loadHierarchy(context_type_);
  }

  public Formalization openExample(String filename) throws RemoteException {
      System.out.println("filename open: " + filename);
      Vector<String> xml_result = loadContent(session_.getId(), "exp", filename);
      String xml_string = (String) xml_result.get(0);

      FormalizationDigest fd = new FormalizationDigest();
      return fd.parseFormalization(xml_string);
  }

  @Override
  protected void drawButtons() {
    throw new UnsupportedOperationException("Not supported yet.");
  }
}