/**
 * @author Walther Neuper, member of the ISAC-team, Copyright (c) 2004 by
 * Walther Neuper created Nov 4, 2004, 6:15:04 PM Institute for
 * Softwaretechnology, Graz University of Technology, Austria.
 * 
 * @deprecated because this class has been intermingled (in Bridge and java-tests) 
 * with the method using the same identifier
 * 
 * Use is subject to license terms.
 */
package isac.bridge;

import java.io.Serializable;

import isac.util.formulae.Position;

/**
 * Contains the 3 iterators which describe the changes in a CalcTree caused by
 * one step (a Tactic or an input Formula).
 *  ? include Message here ? allow (a)Message AND (b)iterators in parallel ??
 * one of (a)|(b)=null would mean: nothing happened; both =null impossible
 * 
 * @author Walther Neuper Nov 4, 2004, 6:15:04 PM
 * @version 1.0
 */
public class CChanged  extends CEvent implements Serializable {

    // trial for Digest: ^^^^^^^^^^^^^^^^^^^^^^^ WN041105

    static final long serialVersionUID = -6752934644057319684L;

    /**
     * @see isac.util.CalcChanged#getLastUnchangedFormula()
     */
    Position last_unchanged_formula_;

    /**
     * @see isac.util.CalcChanged#getLastDeletedFormula()
     */
    Position last_deleted_formula_;

    /**
     * @see isac.util.CalcChanged#getLastGeneratedFormula()
     */
    Position last_generated_formula_;

    public CChanged() {
    }

    public CChanged(Position unchanged, Position deleted, Position generated) {
    	last_unchanged_formula_ = unchanged;
    	last_deleted_formula_ = deleted;
    	last_generated_formula_ = generated;
    }
    
    public void setLastUnchanged(Position last_unchanged_formula) {
        last_unchanged_formula_ = last_unchanged_formula;
    }

    public void setLastDeleted(Position last_deleted_formula) {
        last_deleted_formula_ = last_deleted_formula;
    }

    public void setLastGenerated(Position last_generated_formula) {
        last_generated_formula_ = last_generated_formula;
    }

    public Position getLastUnchanged() {
        return last_unchanged_formula_;
    }

    public Position getLastDeleted() {
        return last_deleted_formula_;
    }

    public Position getLastGenerated() {
        return last_generated_formula_;
    }

}