/* 
 * @author Walther Neuper
 * Copyright (c) due to license terms
 * Created on Aug 16, 2015
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 */

package isac.bridge.xml;

import isac.bridge.xml.DataTypes;
import isac.util.tactics.TermTactic;
import isac.util.tactics.Rewrite;
import isac.util.tactics.RewriteInst;
import isac.util.tactics.RewriteSet;
import isac.util.tactics.RewriteSetInst;
import isac.util.tactics.SimpleTactic;
import isac.util.tactics.StringListTactic;
import isac.util.tactics.SubProblemTactic;
import isac.util.tactics.Tactic;
import info.hupel.isabelle.api.XML;

/**
 * Trials to cope with type conversions between Java and Scala.
 */
public class DataTypesCompanion {
	
	// in Scala no way was found for accepting the type conversions:
	//
	//  def xml_of_Tactic(tac: Tactic): isabelle.XML.Tree = tac.getClass.getSimpleName match {
	//    case "SubProblemTactic" => xml_of_SubProblemTactic((SubProblemTactic)tac)
	//    //Substitute  TODO clarify
	//    case "Rewrite" => xml_of_Rewrite((Rewrite)tac)
	//    case "RewriteInst" => xml_of_RewriteInst((RewriteInst)tac)
	//    case "RewriteSet" => xml_of_RewriteSet((RewriteSet)tac)
	//    case "RewriteSetInst" => xml_of_RewriteSetInst((RewriteSetInst)tac)
	//    case "TermTactic" => xml_of_TermTactic((TermTactic)tac)
	//    case "SimpleTactic" => xml_of_SimpleTactic((SimpleTactic)tac)
	//    case "StringListTactic" => xml_of_StringListTactic((StringListTactic)tac)
	//    case str => 
	//      throw new IllegalArgumentException("xml_of_Tactic: case \"" + str + "\" not covered")
	//  }
	// ERROR "This method must return a result of type XML.tree".
	//
	public static XML.Tree xml_of_Tactic (Tactic tac) {
		XML.Tree return_val = null;
	  if (tac instanceof SubProblemTactic) 
		return (XML.Tree)DataTypes.xml_of_SubProblemTactic((SubProblemTactic)tac);
	  //else if (tac instanceof Substitute) 
	  //  return_val =  isabelle.XML.Tree)DataTypes.xml_of_Substitute((Substitute)tac);
	  else if ((tac instanceof Rewrite))
		  return_val =  (XML.Tree)DataTypes.xml_of_Rewrite((Rewrite)tac);
	  else if (tac instanceof RewriteInst)
		  return_val =  (XML.Tree)DataTypes.xml_of_RewriteInst((RewriteInst)tac);
	  else if (tac instanceof RewriteSet)
		  return_val =  (XML.Tree)DataTypes.xml_of_RewriteSet((RewriteSet)tac);
	  else if (tac instanceof RewriteSetInst) 
		  return_val =  (XML.Tree)DataTypes.xml_of_RewriteSetInst((RewriteSetInst)tac);
	  else if (tac instanceof TermTactic) 
		  return_val =  (XML.Tree)DataTypes.xml_of_TermTactic((TermTactic)tac);
	  else if (tac instanceof SimpleTactic) 
		  return_val =  (XML.Tree)DataTypes.xml_of_SimpleTactic((SimpleTactic)tac);
	  else if (tac instanceof StringListTactic) 
		  return_val =  (XML.Tree)DataTypes.xml_of_StringListTactic((StringListTactic)tac);
	return return_val;
	}
	

}
