/* 
 * @author Walther Neuper
 * Copyright (c) due to license terms
 * Created on Jul 14, 2015
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 */
package isac.bridge.xml;

import isac.bridge.CMessage;

/**
 * compounds calcid and isac.bridge.CMessage
 * for transport from libisabelle/PIDE to isac-java.
 * 
 * Requests from steps in calculations in the Worksheet either
 * get a CChanged or a CMessage, both inherited from CEvent.
 * @author Walther Neuper
 */
public class IntCMessage {

    private Integer calcid_;
    private CMessage cmessage_;
    
    /* Constructor for conversion from XML */
    public IntCMessage(Integer calcid, CMessage cmessage) {
    	
    	calcid_ = calcid;
    	cmessage_ = cmessage;
    }
    
    public Integer getCalcId() {
        return calcid_;
    }  
    public CMessage getCalcHead() {
        return cmessage_;
    }  

}