/* 
 * @author Walther Neuper
 * Copyright (c) due to license terms
 * Created on Jul 14, 2015
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 */
package isac.bridge.xml;

import isac.util.formulae.CalcFormula;

/**
 * compounds calcid and members of isac.util.formulae.CalcFormula
 * for transport from libisabelle/PIDE to isac-java.
 * 
 * Isackernel#Frontend#refFormula either returns CalcFormula or CalcHead,
 * so type cast is required from Object to CalcFormula or CalcHead.
 * @author Walther Neuper
 */
public class IntCalcFormula {

    private Integer calcid_;
    private CalcFormula form_;
    
    /* Constructor for conversion from XML */
    public IntCalcFormula(Integer calcid, CalcFormula form) {
    	calcid_ = calcid;
    	form_ = form;
    }
    
    public Integer getCalcId() {
        return calcid_;
    }  
    public CalcFormula getFormula() {
        return form_;
    }  
    
}