/* 
 * @author Walther Neuper
 * Copyright (c) due to license terms
 * Created on Jul 14, 2015
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 */
package isac.bridge.xml;

import isac.util.formulae.CalcHead;


/**
 * compounds calcid and members of isac.util.formulae.CalcHead
 * for transport from libisabelle/PIDE to isac-java.
 * 
 * Isackernel#Frontend#refFormula either returns CalcFormula or CalcHead,
 * so type cast is required from Object to CalcFormula or CalcHead.
 * @author Walther Neuper
 */
public class IntCalcHead {

    private Integer calcid_;
    private CalcHead calc_head_;
    
    /* Constructor for conversion from XML */
    public IntCalcHead(Integer calcid, CalcHead calc_head) {
    	
    	calcid_ = calcid;
    	calc_head_ = calc_head;
    }
    
    public Integer getCalcId() {
        return calcid_;
    }  
    public CalcHead getCalcHead() {
        return calc_head_;
    }  

}