/* 
 * @author Walther Neuper
 * Copyright (c) due to license terms
 * Created on Jul 14, 2015
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 */
package isac.bridge.xml;


/**
 * compounds calcid and members of isac.util.formulae.CalcFormula
 * and isac.util.formulae.CalcHead for transport from libisabelle/PIDE to isac-java.
 * 
 * Isackernel#Frontend#refFormula either returns CalcFormula or CalcHead,
 * so form_head_ is type Object.
 * @author Walther Neuper
 */
public class IntFormHead {

    private Integer calcid_;
    /* Object is either CalcFormula, CalcHead or Message */
    Object form_head_;
    
    /* Constructor for conversion from XML */
    public IntFormHead(Integer calcid, Object form_head) {
    	calcid_ = calcid;
    	form_head_ = form_head;
    }
    
    public Integer getCalcId() {
        return calcid_;
    }
    //returns either CalcFormula or CalcHead
    public Object getFormHead() {
        return form_head_;
    }  

}