/* 
 * @author Walther Neuper
 * Copyright (c) due to license terms
 * Created on Jul 14, 2015
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 */
package isac.bridge.xml;

import isac.util.formulae.CalcFormula;

import java.util.Vector;

/**
 * compounds calcid and members of isac.util.formulae.CalcHead
 * for transport from libisabelle/PIDE to isac-java.
 * 
 * Isackernel#Frontend#refFormula either returns CalcFormula or CalcHead,
 * so type cast is required from Object to CalcFormula or CalcHead.
 * @author Walther Neuper
 */
public class IntFormulas {

    private Integer calcid_;
    private Vector<CalcFormula> calc_forms_;
    
    /* Constructor for conversion from XML */
    public IntFormulas(Integer calcid, Vector<CalcFormula> calc_forms) {
    	
    	calcid_ = calcid;
    	calc_forms_ = calc_forms;
    }
    
    public Integer getCalcId() {
        return calcid_;
    }  
    public Vector<CalcFormula> getCalcFormulas() {
        return calc_forms_;
    }  

}