/****************************************************************** 
 * Copyright (c) 2003, Mario Hochreiter, Student of 
 * Software Engineering at FH-Hagenberg, Austria. 
 * Project member of the isac team at the Institute for 
 * Software-Technologie, Graz University of Technology, Austria. 
 * 
 * Use is subject to license terms.
 ******************************************************************/

package isac.gui.browser;

import isac.gui.util.Hierarchy;
import isac.gui.util.HierarchyNode;
import isac.util.formulae.HierarchyKey;

import java.util.Vector;

import javax.swing.event.TreeModelListener;
import javax.swing.tree.TreeModel;
import javax.swing.tree.TreePath;

/**
 * TreeModel for the ExampleBrowser
 * 
 * @author Mario Hochreiter, JL
 * @version 1.0
 *  
 */
public class BrowserTreeModel implements TreeModel {

    protected Hierarchy hierarchy_;

    public BrowserTreeModel(Hierarchy hierarchy) {
        this.hierarchy_ = hierarchy;
    }

    public Object getRoot() {
        return hierarchy_.getRoot();
    }

    public int getChildCount(Object parent) {
        HierarchyNode parNode = (HierarchyNode) parent;
        Vector<HierarchyNode> children = hierarchy_.getChildren(parNode);
        return children.size();
    }

    public boolean isLeaf(Object node) {
        return ( getChildCount( node ) == 0 );
    }

    public void addTreeModelListener(TreeModelListener l) {
        //TODO implement
    }

    public void removeTreeModelListener(TreeModelListener l) {

    }

    public Object getChild(Object parent, int index) {
        return hierarchy_.getChild((HierarchyNode) parent, index);
    }

    public int getIndexOfChild(Object parent, Object child) {
    	int index = hierarchy_.getIndexOfChild((HierarchyNode) parent,
                (HierarchyNode) child); 
        return index;
    }

    public void valueForPathChanged(TreePath path, Object newValue) {
        //TODO implement
    }

	/**
	 * To select the Node in the Tree we need the node out of the model
	 * selected by the ke store id.
	 * 
	 * @param id
	 * @return
	 */
	public TreePath getPath(HierarchyKey id) {
		return hierarchy_.getPath(id.getID());
	}
	
	public TreePath getPath(HierarchyNode node) {
		return hierarchy_.getPathToNode(node);
	}

}