package isac.gui.browser.minibrowser;

import javax.swing.text.Element;
import javax.swing.text.View;

/**
 * 
 * This interface performs the conversion between javax.swig.text.Element
 * and the java,swing.text.View. Classes that implement this interface can 
 * render various tags not supported by HTML.
 * For one of the implementing classes see ContextRenderer class.
 * 
 * @author Nelle
 *
 */
public interface IHTMLElementRenderer {

	/**
	 * Performs the conversion from Element to View
	 * @param element - element to be rendered
	 * @return the rendering View
	 */
	public View renderElement( Element element );
	
}
