/*
 * Created on 08.07.2005
 *
 * TOOODO JL: Implement MiniBrowserInterface
 */
package isac.gui.browser.minibrowser;

import isac.interfaces.IToGUI;

import java.io.IOException;
import java.net.URL;

import javax.swing.event.HyperlinkListener;

/**
 * MiniBrowserInterface
 * 
 * This Inteface should be used to encapsulate the XMiniBrowser implementation
 * from the rest of the isac system. Maybee we want to change the XMiniBrowser
 * implementation later to a better one.
 * 
 * @author JL
 * @version $Revision: 1.2 $
 *
 */
public interface IMiniBrowser extends IToGUI {

	/*
	 * setPage
	 * 
	 * To set the new html page to display
	 * 
	 * @param url the url to the new page
	 */
	public void setPage(String url) throws IOException;
	
	/*
	 * To set the new html page with an URL object
	 * 
	 * @param url the URL object to use
	 */
	public void setPage(URL url) throws IOException;
	
	/*
	 * to add a new HyperlinkListener
	 * 
	 * @param hyper_link_listener the listener to add
	 */
	public void addHyperlinkListener(HyperlinkListener hyper_link_listener);
	
	/*
	 * to delete a added HyperlinkListener
	 * 
	 * @param hyper_link_listener the listener to delete
	 */
	public void removeHyperlinkListener(HyperlinkListener hyper_link_listener);
	
	/*
	 * returns a list of all added listeners
	 * 
	 * @returns list of listeners
	 */
	public HyperlinkListener[] getHyperlinkListeners();
}
