package isac.gui.mawen.editor

import isac.gui.mawen.syntax.Ast;
import isac.interfaces.IEditor

/**
 * Notifies (the Worksheet) about key actions.
 */
object EditorListenerHandler {
  
  var editorInstances= Map.empty[AstContainer, IEditor]
  def fireNotifyLocalCheck(c: AstContainer) {
    editorInstances.get(c) match {
      case Some(editor) => editor.fireNotifyLocalCheck()
      case None => {}
    }
  }
  def fireNotifyIsaCheck(c: AstContainer) {
    editorInstances.get(c) match {
      case Some(editor) => editor.fireNotifyIsaCheck()
      case None => {}
    }
  }
  def fireNotifysBraille(c: AstContainer,  formula: Ast.Ast) {
    editorInstances.get(c) match {
      case Some(editor) => editor.fireNotifyBraille(formula)
      case None => {}
    }
  }
  def addListenerHandler(editor: IEditor, c: AstContainer) {
    editorInstances  = editorInstances + (c -> editor)
  }
}