package isac.gui.mawen.editor;

import isac.gui.mawen.syntax.Ast;
import isac.interfaces.IEditor;

import java.awt.*;
import java.util.ArrayList;
import javax.swing.*;

/**
 * Manages the editor for one formula represented by an <code>Ast</code>
 * in the <code>Worksheet</code>.
 */
public class EditorPanel extends JPanel implements IEditor  {

  private static final long serialVersionUID = 1L;
  protected ArrayList<EditorListener> listeners;
  private JComponent component;

/*err*/public EditorPanel(Ast.Ast ast) {
    listeners = new ArrayList<EditorListener>();
    LayoutManager overlay = new OverlayLayout(this);
    this.setBackground(Color.WHITE);
    setLayout(overlay);
	component = CalcUtil.assembleComponent(ast);
	EditorListenerHandler.addListenerHandler((IEditor)this, (AstContainer)component);
	add(component);
  }
  @Override
  public JComponent getComponent() {
    return this;
  }
  @Override
  public void setFormula(String formula) {
   
  }
  @Override
/*err*/public void setFormula(Ast.Ast formula) {
    ((AstComponent)component).setAst(formula);
  }
/*err*/public Ast.Ast getFormula() {
/*err*/return ((AstComponent)component).getAst();
  }
  public void addEditorListener(EditorListener l) {
    listeners.add(l);
  }
  public void removeEditorListener(EditorListener l) {
    listeners.remove(l);
  }
  public void fireNotifyLocalCheck() {
    for(EditorListener l : listeners) {
      l.notifyLocalCheck();
    }
  }
  public void fireNotifyIsaCheck() {
    for(EditorListener l : listeners) {
      l.notifyIsaCheck();
    }
  }
/*err*/public void fireNotifyBraille(Ast.Ast formula) {
	    for(EditorListener l : listeners) {
	      l.notifyBraille(formula);
	    }
	  }
  @Override
  public Dimension getExpressionSize() {
    return new Dimension(Math.max(component.getSize().width, 50), Math.max(component.getSize().height, 50)) ;
  }
  @Override
  public boolean setEditable() {
    return false;
  }
  @Override
  public String getMathText() {
/*err*/return Ast.math_string_of(getFormula() );
  }
}
