package isac.gui.mawen.termtree;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.Enumeration;

import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreePath;
/*
 * This class is needed for manipulation on mawen's termtree.
 * It shall provide the same options as <code>TermTreeKeyAdapter</code>
 * It was created to give the possibility to visually impaired people and regular 
 * sighted people to work together on the termtree.
 * 
 * @author NK 20072016
 * 
 */
public class TermTreeMouseAdapter extends MouseAdapter{
  JTree main_tree_;
  DefaultMutableTreeNode selected_node_;
  boolean initialised_ = false;
  
  public TermTreeMouseAdapter(JTree tree){
    main_tree_=tree;
  }
  @Override
    public void mouseReleased(MouseEvent e) {
      int selRow = main_tree_.getRowForLocation(e.getX(), e.getY());
      TreePath selPath = main_tree_.getPathForLocation(e.getX(), e.getY());
      if(selRow != -1) {
        DefaultMutableTreeNode selectedNode = (DefaultMutableTreeNode) selPath.getLastPathComponent();
          if(e.getClickCount() == 1) {
            if(!selectedNode.isLeaf()){
            if(main_tree_.isExpanded(selPath)){
                main_tree_.collapsePath(selPath);
                setCollapsed(selectedNode, true);
                collapseRecursive(selectedNode);
             }else{
                main_tree_.expandPath(selPath);
                setCollapsed(selectedNode, false);
                Enumeration<DefaultMutableTreeNode> it = selectedNode.children();
                while (it.hasMoreElements()){
                  DefaultMutableTreeNode child = it.nextElement();
                  main_tree_.collapsePath(new TreePath(child.getPath()));
                  setCollapsed(child, true);
                }    

              }
            }
          }
      }
    }
  
  private void setCollapsed(DefaultMutableTreeNode node, boolean collapsed) {
    if (!node.isLeaf()) ((TreeNodeContent)node.getUserObject()).setCollapsed(collapsed);
    ((DefaultTreeModel)main_tree_.getModel()).nodeChanged(node);    
  }

  private void collapseRecursive(DefaultMutableTreeNode node){
    Enumeration<DefaultMutableTreeNode> it = node.children();
    while (it.hasMoreElements()){
      DefaultMutableTreeNode child = it.nextElement();
      collapseRecursive(child);
    }
    TreePath path = new TreePath(node.getPath());
    if (main_tree_.isExpanded((path))){
      main_tree_.collapsePath(path);
      setCollapsed(node, true);
    }
  }
}

