package isac.gui.mawen.termtree;



/**
 * This is the user-object class for the DefaultMutableTreeNode class in the TermTree.
 * It contains two strings: the current shown character and when collapsed the term
 * of the nodes which lie beneath.
 * 
 *@author NK 23052016
 **/
public class TreeNodeContent {
  private String expanded_string_;
  private String collapsed_string_;
  private boolean collapsed_;

  public TreeNodeContent(String expanded_string_, String collapsed_string_) {
    super();
    this.expanded_string_ = expanded_string_;
    this.collapsed_string_ = collapsed_string_;
  }
  /*
   * ctor for test purposes
   * collapsed_string_ should later be null and the purpose for this
   * ctor shall be the leaf's content
   */
  public TreeNodeContent(String expanded_string_) {
    super();
    this.expanded_string_ = expanded_string_;
    collapsed_string_="string n/a";
  }
  
  public String getExpanded_string_() {
    return expanded_string_;
  }
  public void setExpanded_string_(String expanded_string_) {
    this.expanded_string_ = expanded_string_;
  }
  public String getCollapsed_string_() {
    return collapsed_string_;
  }
  public void setCollapsed_string_(String collapsed_string_) {
    this.collapsed_string_ = collapsed_string_;
  }
  
  public void setCollapsed(boolean col){
     collapsed_=col;
  }
  public boolean isCollapsed(){
    return collapsed_;
  }
  
  @Override
  public String toString() {
    if(collapsed_){
      return collapsed_string_;
    }
    return expanded_string_;
  }

  @Override
  public boolean equals(Object obj) {
    if(obj.toString().equals(this.toString())){
      return false;
    }
    return true;
  }
  
}
