package isac.gui.mawen.termtree;

import java.awt.event.KeyListener;
import java.awt.event.MouseListener;

import isac.gui.mawen.scalaterm.Util;
import isac.util.formulae.CalcFormula;

import javax.swing.JPanel;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreePath;


/**
 * content to be reintegrated into Worksheet when code for TermTreeEditor tested properly
 * @author NK 07062016
 *
 */
public class WSHelper {

  public JPanel getTermTree(CalcFormula cf) {
    JTree term_tree= new JTree(Util.jtree_of(cf.getTerm()));
    initTermTree(term_tree);
    TermTreePanel test_panel= new TermTreePanel(term_tree);
    test_panel.setSize(300,200);
    test_panel.setVisible(true);
    term_tree.setSelectionRow(0);
    return test_panel;
  }
  
  /*
   * copy from TestTermTreeView
   * necessary to remove default behavior of JTree
   */
  private void initTermTree(JTree main_tree_) {
    //collapse all nodes
    for (int i = 0; i < main_tree_.getRowCount(); i++) {
      main_tree_.collapseRow(i);
      TreePath path = main_tree_.getPathForRow(i);
      DefaultMutableTreeNode node = (DefaultMutableTreeNode) path.getLastPathComponent();
      ((TreeNodeContent)node.getUserObject()).setCollapsed(true);
      ((DefaultTreeModel)main_tree_.getModel()).nodeChanged(node);  
    }

    //remove default behavior
    for(MouseListener ml : main_tree_.getMouseListeners()){
      main_tree_.removeMouseListener(ml);
    }
    main_tree_.addMouseListener(new TermTreeMouseAdapter(main_tree_)); 
    
    for(KeyListener kl : main_tree_.getKeyListeners()){
        main_tree_.removeKeyListener(kl);
    }
    main_tree_.addKeyListener(new TermTreeKeyAdapter(main_tree_));
  }
}
