package isac.gui.treetable;

import java.io.InputStream;
import java.util.Properties;

import isac.gui.mawen.editor.EditorPanel;
import isac.interfaces.IEditor;
import isac.util.WindowApplicationPaths;

/**
 * Given a property file decide to use which kind of editor.
 */
public class EditorFactory {
  private static boolean IsEditorVisible;
	static {
	    try {
	      InputStream is = WindowApplicationPaths.class.getResourceAsStream("/properties/Editor.properties");
	      if (is != null) {
	        Properties p = new Properties();
	        p.load(is);
	        System.out.println("contains: " + p.containsKey("EDITOR"));
	        System.out.println("EDITOR: " + p.getProperty("EDITOR"));
	        IsEditorVisible = p.getProperty("EDITOR").replace(" ", "").equalsIgnoreCase("MAWEN");
	      }
	    } catch (Exception e) {
	      IsEditorVisible = false;
	    }
	  }
	public static IEditor getTacticEditor() {
		if (!IsEditorVisible) { // StringEditor is true
	    	return new TacticTextField();
	    } else { // FormulaEditor is true
	    	// TODO: Insert Formula editor
	    }
		return new TacticTextField();
	}
	
	public static IEditor getFormulaEditor() {
	  
    if (IsEditorVisible) { // StringEditor is true
        //WHY not <code>Constant("BOX")</code> ?      
/*err*/return new EditorPanel(new isac.gui.mawen.syntax.Ast.Constant("x"));
    }
    return new FormulaTextField();
	}
}
