package isac.interfaces;

import isac.gui.mawen.editor.EditorListener;
import isac.gui.mawen.syntax.Ast;
import java.awt.Dimension;
import javax.swing.JComponent;

public interface IEditor {
  /*
   * <code>TreeCellEditor</code> and <code>TreeCellRenderer</code> returns 
   * either <code>StringEditor</code> or <code>EditorPanel</code>
   */
  JComponent getComponent();
  
/*err*/void setFormula(Ast.Ast formula); // Java cannot distinguish betwenn class and object

  // <code>Formula</code> still contains a String in parallel to an Ast, removed eventually.
  void setFormula(String formula);
/*err*/Ast.Ast getFormula();
  String getMathText();

  /*
   * Returns the size of the mathematical expression; is relevant after
   * each edit, which changes the size (e.g. introduction of an exponent).
   */
  Dimension getExpressionSize();

  /*
   * Mode for an <code>JTree</code> node
   */
  boolean setEditable();
  
  void addEditorListener(EditorListener l);
  void removeEditorListener(EditorListener l);
  
  /*
   * check either in front-end (local) or by Isabelle
   */
  void fireNotifyLocalCheck();
  void fireNotifyIsaCheck();
  
  /*
   * Fired in case arrow-keys select another sub-term
   * and in case of editing at each input key.
   * 
   * Ast is translated to strings according to different standards
   * outside the editor
   */
/*err*/void fireNotifyBraille(Ast.Ast formula);
}
