package isac.session;

import isac.users.LogItem;
import isac.users.UserLogger;
import isac.util.FileUtils;
import isac.util.ObjectManagerPaths;
import java.util.Properties;

/**
 * One DialogGuide for one user, like Session.
 * Session handles technical issues for a user, DialogGuide handles
 * learning issues for a user.
 *
 * TODO handle learning issues (collate characteristics from all dialog
 * of the user)
 *
 * Here is the only place where the UserLogger is written to.
 * 
 * @author franz
 */
public class DialogGuide { //rename to DialogGuide according to UR, SR
  
  private UserLogger user_logger_ = null;
  private Properties error_patterns__hint_pages = null;
  
  public DialogGuide() {
    String filename = ObjectManagerPaths.SESSION_MANAGER_USER_PATH +
      "../error_patterns__hint_pages.properties";//TODO: separate path ?
    Properties error_patterns__hint_pages = new Properties();
    FileUtils.loadPropertiesFromFile(filename, error_patterns__hint_pages, 
      "error_patterns__hint_pages.properties");
    
    if(ObjectManagerPaths.LOGGER_DATABASE_ENABLED)
      user_logger_ = UserLogger.getInstance();
  }

  public String getHintPage (String error_pattern) {
    return error_patterns__hint_pages.getProperty(error_pattern);
  }

  public void writeToDB(LogItem log_item) {
    if(ObjectManagerPaths.LOGGER_DATABASE_ENABLED){
      user_logger_.saveLogItem(log_item);    
    }
  }
}
