package isac.session;

import isac.util.StringUtils;

/**
 *
 * @author thomas.zillinger
 */
public enum LearningMode {

    ASSESSMENT,
    LEARNER;

    public static boolean isValidLearningMode(String learningMode) {
        try {
            getLearningModeOf(learningMode);
            return true;
        } catch (IllegalArgumentException ex) {
            return false;
        }
    }

    public static LearningMode getLearningModeOf(String learningMode) {
        return LearningMode.valueOf(StringUtils.emptyStringIfNull(learningMode).trim().toUpperCase());
    }
    
    public static LearningMode getLearningModeOrDefault(String learningMode, LearningMode defaultLearningMode) {
        try {
            LearningMode mode = getLearningModeOf(learningMode);
            return mode;
        } catch (IllegalArgumentException ex) {
            return defaultLearningMode;
        }
    }
}
