/*
 * @author Manuel Koschuch, member of the ISAC-team, 
 * Copyright (c) 2005 by Manuel Koschuch
 * created Aug 9, 2005 3:15:19 PM
 * Institute for Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to PGPL license terms.
 */
package isac.useractions;

import isac.interfaces.ICalcElement;
import isac.users.UserLanguage;
import isac.util.formulae.Position;

/**
 * Describes a user-interface action which has to pass a CalcElement for display
 * on the gui.
 * 
 * @see isac.useractions.UIActionOnIterator
 * @see isac.useractions.UIActionOnString
 * @author Manuel Koschuch
 */
public class UIActionOnCalcElement extends UIAction {
    
	static final long serialVersionUID = 9017265256748316691L;
    
	private ICalcElement calc_element_;

    public UIActionOnCalcElement(EUIElement action, EUIContext context, UserLanguage ul, Position pos, ICalcElement element) {
        super(action, context, pos, ul);
        calc_element_ = element;
    }
    
    public UIActionOnCalcElement(EUIElement action, EUIContext context, UserLanguage ul, ICalcElement element) {
        super(action, context, ul);
        calc_element_ = element;
    }

    public ICalcElement getCalcElement() {
        return calc_element_;
    }

}