
package isac.useractions;

import isac.users.UserLanguage;
import isac.util.formulae.Model;

/**
 * A UIAction that transports a model object
 * 
 * @author Johannes Loinig
 * @version $Revision: 1.4 $
 */
public class UIActionOnModel extends UIAction {

	static final long serialVersionUID = 3577705803437202383L;
	
	private Model model_;
	
	/**
	 * Constructs the action
	 * 
	 * @param id action id
	 * @param context action context
	 * @param model the model to send
	 */
	public UIActionOnModel(EUIElement id, EUIContext context, UserLanguage ul, Model model) {
		super(id, context, ul);
		model_ = model;
	}
	
	/**
	 * returns the stored ModelPanel
	 * 
	 * @return with constructor stored model
	 */
	public Model getModel() {
		return model_;
	}

}
