/*
 * Created on Feb 6, 2004
 */
package isac.useractions;

import isac.interfaces.ICalcElement;
import isac.util.formulae.Position;

/**
 * Describes a user action (i.e. direction gui --> dialog) which has to pass a
 * CalcElement, e.g a newly entered formula which is not yet part of
 * the calculation tree.
 * 
 * @see isac.useractions.UserActionOnIterator
 * @see isac.useractions.UserActionOnKEStoreID
 * @author Alan Krempler
 */
public class UserActionOnCalcElement extends UserAction {
	
    static final long serialVersionUID = -5350058690628467503L;
    
	private ICalcElement calc_element_;
	
	private Position	 position_;

    public UserActionOnCalcElement(EUIElement id, EUIContext context, Position pos, ICalcElement calc_element) {
        super(id, context);
        position_ = pos;
        calc_element_ = calc_element;
    }
    
    public UserActionOnCalcElement(EUIElement id, ICalcElement calc_element) {
        super(id);
        calc_element_ = calc_element;
    }

    public ICalcElement getCalcElement() {
        return calc_element_;
    }

	/**
	 * @return Returns the position_.
	 */
	public Position getPosition() {
		return position_;
	}

	/**
	 * @param position_ The position_ to set.
	 */
	public void setPosition(Position position) {
		position_ = position;
	}

}