/****************************************************************** 
 * @author Alois Kirchsteiger member of the isac team
 * Copyright (c) 2005 by Alois Kirchsteiger
 * create 21.02.2005, 08:41:56
 * Insitute for Softwaretechnology, Graz University of Technology, Austria. 
 * 
 * Use is subject to license terms.
 ******************************************************************/

package isac.util;

/**
 * @author Alois Kirchsteiger 21.02.2005 08:41:56
 * WN120612 we keep this class simple dealing just with String;
 *    for Errorpatterns (ML: errpat) and Fillpatterns (ML: fillpat)
 *    this is still reasonable, but might be elaborated in the future.
 * 
 * @see isac.bridge.CMessage WN050729 !?!
 */
public class CalcMessage extends CalcEvent {

    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	String text_;

    /**
     * contructor of the CalcMessage
     * 
     * @param message:
     *            the Message the bridge sends to the worksheet
     */
    public CalcMessage(String message) {
        text_ = message;
    }

    /**
     * the constructor for ...
     * @see org.apache.commons.digester.Digester
     * @author Walther Neuper
     * @version 1.0
     */
    public CalcMessage() {
        text_ = new String();
    }

    public void setText(String text) {
        text_ = text;
    }
    public String getText() {
        return text_;
    }

  /**
   * simple ad-hoc version for Errorpatterns.
   *
   * @arg CalcMessage e.g: "error pattern #chain-rule-diff-both#"
   * @return String, e.g:
   *    if pattern found: "chain-rule-diff-both"
   *    if no pattern found: "#nothing found#"
   */
  public String checkForErropattern (CalcMessage cm) {
    String msg = cm.getText();
    String[] err_pat = msg.split("#");
    if (err_pat[0].equals("error pattern "))
      return err_pat[1];
    else
      return "#nothing found#";
  }
}