package isac.util;

import java.io.InputStream;
import java.util.Properties;

public class WindowApplicationPaths {
    
    static {
	loadPropertyFile();
    }
    
    public static void loadPropertyFile() {
	try {
		InputStream is = WindowApplicationPaths.class.getResourceAsStream("/properties/WindowApplication.properties");
	    if (is != null) {
		Properties p = new Properties();
		p.load(is);
		WORKSHEET_RMI = p.getProperty("WORKSHEET_RMI");
		BROWSER_FRAME_RMI = p.getProperty("BROWSER_FRAME_RMI");
		OBJECT_MANAGER_RMI = p.getProperty("OBJECT_MANAGER_RMI");
		WINDOW_APPLICATION_REVERSE_RMI_SERVER = p.getProperty("WINDOW_APPLICATION_REVERSE_RMI_SERVER");
		WINDOW_APPLICATION_REVERSE_RMI_PORT = new Integer(p.getProperty("WINDOW_APPLICATION_REVERSE_RMI_PORT")).intValue();
	    }
	} catch (Exception e) {
	    WORKSHEET_RMI = "";
	    BROWSER_FRAME_RMI = "";
	    OBJECT_MANAGER_RMI = "";
	    WINDOW_APPLICATION_REVERSE_RMI_SERVER = "";
	    WINDOW_APPLICATION_REVERSE_RMI_PORT = -1;
	    e.printStackTrace();
	}
    }
	
	/*
	 * The path to the RMI of the Worksheet
	 * //localhost/isac-WorksheetRMI
	 */
	public static String WORKSHEET_RMI;
	
	/*
	 * The path to the RMI of the XBrowserFrame
	 * //localhost/isac-BrowserFrameRMI
	 */	
	public static String BROWSER_FRAME_RMI;
	
	/* 
	 * The path to the ObjectManager RMI
	 * //localhost/isac-ObjectManager
	 *  
	 */
	
	public static String OBJECT_MANAGER_RMI;
	
	/*
	 * The server hostname and port for the Reverse RMI
	 * see WindowApplicationRMISocketFactory for details
	 *  
	 */
	public static String WINDOW_APPLICATION_REVERSE_RMI_SERVER;
	public static int WINDOW_APPLICATION_REVERSE_RMI_PORT;

}
