/*
 * @author Alan Krempler
 * Created on Dec 3, 2003
 */
package isac.util.formulae;

import isac.interfaces.ICalcElement;

/**
 * Abstract base class for formulae, tactics, CalcHeads and assumptions.
 * Implements the visiblity and view style properties.
 * 
 * @author Alan Krempler
 */
public abstract class CalcElement implements ICalcElement {

    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	protected int visibility_;

    protected int view_style_;

    protected int rating_;

    public CalcElement() {
        visibility_ = DISPLAY_VISIBLE_DEFAULT;
        view_style_ = VIEWSTYLE_DEFAULT;
        rating_ = NOT_RATED;
    }

    public int getVisibility() {
        return visibility_;
    }

    public void setVisibility(int visibility) {
        visibility_ = visibility;
    }

    public int getViewStyle() {
        return view_style_;
    }

    public void setViewStyle(int view_style) {
        view_style_ = view_style;
    }

    public int getRating() {
        return rating_;
    }

    public void setRating(int rating) {
        rating_ = rating;
    }

}