/*
 * @author Walther Neuper, member of the ISAC-team, Copyright (c) 2005 by
 * Walther Neuper created Feb 4, 2005 10:21:11 AM Institute for
 * Softwaretechnology, Graz University of Technology, Austria.
 * 
 * Use is subject to PGPL license terms.
 */
package isac.util.formulae;

import isac.gui.mawen.syntax.Ast;

/**
 * contains math concerns for combination with Position (--> CalcFormula),
 * Theorem etc.
 */
public class Formula extends CalcElement {

    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	protected String math_text_;
    protected Ast.Ast term_;

    public Formula(){
    	math_text_ = "";
    }
    public Formula(String math_text){
        super.visibility_ = DISPLAY_VISIBLE_DEFAULT;
        super.view_style_ = VIEWSTYLE_DEFAULT;
        super.rating_ = NOT_RATED;
    	math_text_ = math_text;
    }
    public Formula(String math_text, Ast.Ast t){
        super.visibility_ = DISPLAY_VISIBLE_DEFAULT;
        super.view_style_ = VIEWSTYLE_DEFAULT;
        super.rating_ = NOT_RATED;
    	math_text_ = math_text;
    	term_ = t;
    }
    
    public String toSMLString() {
        return isac.util.parser.FormalizationDigest.decodeEntities(math_text_);
    }

    /*
     * @deprecated: see Formula#getTerm()
     * 
     * @see isac.util.CalcElement#getMathML()
     * @see isac.util.Formula#getTerm()
     */
    public String getMathML() {
        return null;
    }

    /* return a term in libisabelle-format (Scala!) */
    public Ast.Ast getTerm() {
        return term_;
    }

    /*
     * (non-Javadoc)
     * 
     * @see isac.util.CalcElement#getType()
     */
    public int getType() {
        return CALCEL_FORMULA;
    }

    public int setMathML(String math_ML_string) {
        return 0;
    }

    // TODO RG Generated for testing purposes (without the permission of Alan)!
    public void setText(String mathText) {
        this.math_text_ = mathText;
    }

    public String getIsabelle() {
        return "";
    }

    public CalcFormula copyTerm(TermSelector term) {
        CalcFormula dummy;
        dummy = new CalcFormula();
        return dummy;
    }

    public String getBlanked(TermSelector blank_term) {
        return "";
    }
    // WN150817 still always used instead of getMathML
    public String toString() {
        return math_text_;
    }

    
}