/*
 * Created on Sep 19, 2003
 */
package isac.util.formulae;

import isac.util.formulae.ModelItem;

import java.io.Serializable;
import java.util.Iterator;
import java.util.Vector;

/**
 * @author Richard Gradischnegg
 * @author Manuel Koschuch
 */
public class ModelItemList implements Serializable {

	/**
	 * for serialization, see corresponding API Documentation
	 */
	private static final long serialVersionUID = 506L;

	protected Vector<ModelItem> items_ = new Vector<ModelItem>();

	public ModelItemList() {
		items_ = new Vector<ModelItem>();
	}
	public ModelItemList(Vector<ModelItem> modits) {
		items_ = modits;
	}

	public void addItem(ModelItem item) {
		items_.add(item);
	}

	public Vector<ModelItem> getItems() {
		return (Vector<ModelItem>)items_;
	}

	/**
	 * Show all data contained (item_status_ too much for SML input)
	 * 
	 * @see isac.util.formulae.ModelItem#toSMLString()
	 * @return SML representation
	 */
	public String toString() {
		if (items_.isEmpty()) {
			return "[]";
		} else {
			StringBuffer sb = new StringBuffer();
			sb.append("[");
			Iterator<ModelItem> it = items_.iterator();
			while (it.hasNext()) {
				sb.append("\"");
				sb.append(((ModelItem) it.next()).toString());
				sb.append("\", ");
			}
			sb.deleteCharAt(sb.length() - 2); // remove but last ","
			sb.deleteCharAt(sb.length() - 1); // remove last " "
			sb.append("]");
			return sb.toString();
		}
	}

	/**
	 * Format the object in a way that the bridge can handle it
	 * 
	 * @see isac.util.formulae.ModelItem#toSMLinput()
	 * @return SML representation
	 */
	public String toSMLString() {
		if (items_.isEmpty()) {
			return "[]";
		} else {
			StringBuffer sb = new StringBuffer();
			sb.append("[");
			Iterator<ModelItem> it = items_.iterator();
			while (it.hasNext()) {
				sb.append("\"");
				sb.append(((ModelItem) it.next()).toSMLString());
				sb.append("\", ");
			}
			sb.deleteCharAt(sb.length() - 2); // remove but last ","
			sb.deleteCharAt(sb.length() - 1); // remove last " "
			sb.append("]");
			return sb.toString();
		}
	}

	public int getNumberOfItems() {
		return items_.size();
	}

}