/*
 * @author Richard Gradischnegg
 * Created on Oct 31, 2003
 */
package isac.util.formulae;
import isac.bridge.xml.DataTypes; //.scala

import info.hupel.isabelle.api.XML; //.scala

import java.io.Serializable;

/**
 * @author Richard Gradischnegg
 */

public class Specification implements Serializable {

    static final long serialVersionUID = 5531717778036867586L;

	protected CalcHeadSimpleID theory_;

    protected HierarchyKey problem_, method_;

    public Specification(){}
    public Specification(CalcHeadSimpleID thy, HierarchyKey pbl, HierarchyKey met){
        theory_ = thy;
        problem_ = pbl;
        method_ = met;
    }
    
    public String toSMLString() {
        StringBuffer sb = new StringBuffer();
        sb.append(getTheory().getQuotedID());
        sb.append(",");
        sb.append(getProblem().toSMLString());
        sb.append(",");
        sb.append(getMethod().toSMLString());
        return sb.toString();
    }

    public CalcHeadSimpleID getTheory() {
        return theory_;
    }

    public HierarchyKey getMethod() {
        return method_;
    }

    public HierarchyKey getProblem() {
        return problem_;//(ProblemID)problem_ ---> ClassCastException ?
    }

    public void setTheory(CalcHeadSimpleID el) {
        theory_ = el;
    }

    public void setProblem(HierarchyKey el) {
        problem_ = el;
    }

    public void setMethod(HierarchyKey el) {
        method_ = el;
    }

    //WN0505 this stems from a misunderstanding in 03!
    public String toString() {
        String content = "<SPECIFICATION>\n";
        if (theory_ != null) {
            content += "<THEORY>\n" + theory_ + "</THEORY>\n";
        }
        if (problem_ != null)
            content += "<PROBLEM>\n" + problem_ + "</PROBLEM>\n";
        if (method_ != null) content += "<METHOD>\n" + method_ + "</METHOD>\n";
        content += "</SPECIFICATION>\n";
        return content;
    }
    // conversion is done in Scala, because it is much simpler there
    public XML.Tree toXML() {
    	return DataTypes.xml_of_Specification(this);
    }
}