/*
 * @author Walther Neuper
 * Created on Aug 24 2008
 *  
 */
package isac.util.genhtml;

import isac.util.genhtml.GenHTMLsinglePaths;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;

/**
 * check one xml-file specified in GenHTMLsingle.properties.
 * 
 * FIXME find a better way to reuse GenHTML#loadContent( FileWriter!!!...
 * 
 * !!!!! start KEStore before running GenHTML !!!!!
 */
public class GenHTMLsingle {

    @SuppressWarnings("resource") //..close file not acknowledged bu eclipse
	public static void main(String[] args) {

        // read arguments of main
        if (args.length != 1) {
            System.out.println("invalid arguments for GenHTMLsingle#main()"
                    + " - SYSTEM EXITING");
            System.exit(1);
        }

        // read the one argument, which is the property-file
        Properties properties = new Properties();
        InputStream is = null;

        try {
            is = new FileInputStream(args[0]); //..Warning "never closed"
        } catch (FileNotFoundException e1) {
            is = GenHTMLsingle.class.getResourceAsStream(args[0]);
        }

        if (is == null) {
            System.err.println("No property file found! - SYSTEM EXITING");
            System.exit(-1);
        }

        try {
            properties.load(is);
        } catch (IOException e) {
            e.printStackTrace();
        }

        String filename = "";
        if ((GenHTMLsinglePaths.FILE_TO_CHECK = properties
                .getProperty("FILE_TO_CHECK")) == null) {
            System.err
                    .println("No value for FILE_TO_CHECK found in property-file"
                            + " - SYSTEM EXITING");
            System.exit(-1);
        } else {
            filename = GenHTMLsinglePaths.FILE_TO_CHECK;
            if (!filename.endsWith(".xml")) {
                System.err.println("No XML-file: " + filename
                        + " - SYSTEM EXITING");
                System.exit(-1);
            } else {
                // remove extension ".xml"
                filename = filename.substring(0, filename.length() - 4);
            }
        }

        // destination for reporting HTML-errors in the xml-file
        GenHTML genhtml = new GenHTML();
        String destination = "";
        if ((GenHTMLsinglePaths.GENHTML_DESTINATON_PATH = properties
                .getProperty("GENHTML_DESTINATON_PATH")) == null) {
            System.err
                    .println("No value for GENHTML_DESTINATON_PATH found in property-file"
                            + " - SYSTEM EXITING");
            System.exit(-1);
        } else {
            destination = GenHTMLsinglePaths.GENHTML_DESTINATON_PATH;
        }

        FileWriter error_log = null;
        try {
            error_log = new FileWriter(destination + "GENHTML_error-"
                    + filename + ".txt");
        } catch (IOException e) {
            e.printStackTrace();
        }

        // check the xml-file using all other properties from KEStore.properties
        String type = filename.substring(0, 3);// exp | met | pbl | thy
        System.out.println(type + " to generate:");
        genhtml.loadContent(error_log, destination, type + "/" + filename);

        try {
            error_log.close();
        } catch (IOException e1) {
            e1.printStackTrace();
        }
        if(is!=null){
        	try {
				is.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
        }
    }

}