/*
 * @author Richard Gradischnegg
 * Created on Jun 25, 2004
 */
package isac.util.tactics;

/**
 * @author Richard Gradischnegg
 */
public class Rewrite extends Tactic {

    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	Theorem theorem_;

    public Rewrite() {}
    public Rewrite(String name, Theorem thm) {
      name_ = name;
      theorem_ = thm;
    }


    public String getName() {
        return name_;
    }

    public String toSMLString() {
        return name_ + theorem_.toSMLString();
    }

    /**
     * show a tactic as simple as possible: theorems in rewrite-tactics without
     * '?' etc.
     */
    public String showToBeginner() {
        return theorem_.getFormulaSimplified();
    }

    /**
     * @return
     */
    public Theorem getTheorem() {
        return theorem_;
    }

    /**
     * for use in
     * 
     * @see isac.util.parser.XMLParserDigest.java
     * @param theorem
     */
    public void setTheorem(Theorem theorem) {
        this.theorem_ = theorem;
    }

}