/*
 * @author Richard Gradischnegg
 * Created on Jun 25, 2004
 */
package isac.util.tactics;

/**
 * @author Richard Gradischnegg
 */
public class RewriteInst extends Tactic {
    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	String variable, value;//FIXME.WN082021 this should be a Vektor of pairs !

    Theorem theorem_;

    public RewriteInst() {}
    public RewriteInst(String name, String var, String val, Theorem thm) {
    	name_ = name;
    	variable = var;
    	value = val;
    	theorem_ = thm;    	
    }

    public String getName() {
	    return name_;
	  }

    public String toSMLString() {
        return name_ + " ([\"(" + variable + "," + value + ")\"],"
                + theorem_.toSMLString() + ")";
    }

    /**
     * show a tactic as simple as possible: theorems in rewrite-tactics without
     * '?' etc.
     */
    public String showToBeginner() {
        return theorem_.getFormulaSimplified();
    }

    /**
     * @return
     */
    public String getValue() {
        return value;
    }

    /**
     * @return
     */
    public String getVariable() {
        return variable;
    }

    /**
     * @param string
     */
    public void setValue(String string) {
        value = string;
    }

    /**
     * @param string
     */
    public void setVariable(String string) {
        variable = string;
    }

    /**
     * @return
     */
    public Theorem getTheorem() {
        return theorem_;
    }

    /**
     * @param theorem
     */
    public void setTheorem(Theorem theorem) {
        this.theorem_ = theorem;
    }

}