/*
 * @author Richard Gradischnegg
 * Created on Oct 9, 2003
 */
package isac.util.tactics;

import java.util.Iterator;
import java.util.Vector;

/**
 * @author Richard Gradischnegg
 */
public class StringListTactic extends Tactic {

  /**
	 * 
	 */
	private static final long serialVersionUID = 1L;
private Vector<String> stringList = new Vector<>();

  public StringListTactic() {}
  public StringListTactic(String name) {
    this.name_ = name;
  }
  public StringListTactic(String name, Vector<String> keyList) {
    this.name_ = name;
    this.stringList = keyList;
  }

  public String getName() {
	    return name_;
	  }
  public Vector<String> getStrings() {
      return stringList;
  }
  public void addKey(String key) {
    this.stringList.add(key);
  }

  public String toSMLString() {
    StringBuffer sb = new StringBuffer();
    sb.append(name_);
    if (stringList.size() > 0) {
      sb.append(" [");
      Iterator<String> it = stringList.iterator();
      while (it.hasNext()) {
        sb.append("\"" + it.next() + "\",");
      }
      sb.deleteCharAt(sb.length() - 1); // remove last ","
      sb.append("]");
    }
    return sb.toString();
  }

}
