/*
 * @author Richard Gradischnegg
 * Created on Nov 13, 2003
 */
package isac.util.tactics;

import java.util.Iterator;
import java.util.Vector;

/**
 * @author Richard Gradischnegg
 */
public class SubProblemTactic extends Tactic {

    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	private String theory_id_;

    private Vector<String> problem_id_ = new Vector<>();

    public SubProblemTactic() {}
    public SubProblemTactic(String name, String thy_id, Vector<String> pbl_id) {
      name_ = name;
      theory_id_ = thy_id;
      problem_id_ = pbl_id;
    }

    public void addProblemString(String string) {
        this.problem_id_.add(string);
    }

    public String toSMLString() {
        StringBuffer sb = new StringBuffer();
        sb.append(name_ + " (\"" + theory_id_ + "\", [");
        Iterator<String> it = problem_id_.iterator();
        while (it.hasNext()) {
            sb.append("\"" + it.next() + "\",");
        }
        sb.deleteCharAt(sb.length() - 1); // remove last ","
        sb.append("])");
        return sb.toString();
    }

    public String getName() {
        return name_;
    }

    public Vector<String> getProblemID() {
        return problem_id_;
    }

    public String getTheoryID() {
        return theory_id_;
    }

    public void setProblemID(Vector<String> vector) {
        problem_id_ = vector;
    }

    public void setTheoryID(String string) {
        theory_id_ = string;
    }
}