/*
 * @author Richard Gradischnegg
 * Created on Jun 25, 2004
 */
package isac.util.tactics;

import isac.util.formulae.Formula;

import java.io.Serializable;

/**
 * This is a helper class used by Rewrite Tactic and RewriteInst Tactic
 * 
 * @author Richard Rradischnegg
 */

public class Theorem implements Serializable {
    static final long serialVersionUID = -233677392264313623L;

    String id_;

    String formula_;// FIXME.WN080221 Formula !

    // Theorem consist of the ID, and
    // the formula (still as a string -- waiting for MathML)
    
    public Theorem() {}
    public Theorem(String id, String form) {
    	id_ = id;
    	formula_ = form;
    }

    /**
     * Format the class to a string which can be used as SML-Input
     * 
     * @return
     */
    public String toSMLString() {
        return "(\"" + id_ + "\",\"\")"; // formula may be empty at input
    }

    public String getFormula() {
        return formula_;
    }

    public String getFormulaSimplified() {
        // remove premises, they are hard to understand
        String cut = formula_;
        int prems = formula_.lastIndexOf("==>");
        if (prems > 0) {
            cut = formula_.substring(prems + 4);// "==>" always followed by " "
        }
        // remove '?' as done within Isabelle theories
        char[] cs1 = cut.toCharArray();
        StringBuffer cs2 = new StringBuffer();
        // System.out.println("cut = " + cut);
        for (int i = 0; i < cs1.length; i++) {
            if (cs1[i] != '?') {
                cs2.append(cs1[i]);
            }
            // System.out.println("i = " + i + ", cs1[i] = " + cs1[i] + ", cs2 =
            // "
            // + cs2.toString());
        }
        return cs2.toString();
    }

    public String getId() {
        return id_;
    }

    // WN060327 quick and dirty for XMLParserDigest
    public void setFormula(Formula form) {
        formula_ = form.toSMLString();
    }

    public void setFormula(String string) {
        formula_ = string;
    }

    public void setId(String string) {
        id_ = string;
    }

}